
{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Turbo Vision Unit                               }
{                                                       }
{       Copyright (c) 1992 Borland International        }
{                                                       }
{*******************************************************}

unit App;

{$i platform.inc}

{$ifdef PPC_FPC}
  {$H-}
{$else}
  {$F+,O+,E+,N+}
{$endif}
{$X+,R-,I-,Q-,V-}
{$ifndef OS_LINUX}
  {$S-}
{$endif}

interface

uses
{$ifdef OS_WINDOWS}
  Windows,
{$endif OS_WINDOWS}
  Dos,Video,Mouse,
  Commands, HelpCtx,
  Objects, Drivers, Memory, HistList,
  Views, Menus, Dialogs, Resource, MsgBox;

const

{ TApplication palette entries }

  apColor      = 0;
  apBlackWhite = 1;
  apMonochrome = 2;

{ TApplication palettes }

  { Turbo Vision 1.0 Color Palettes }

  CColor =
        #$71#$70#$78#$74#$20#$28#$24#$17#$1F#$1A#$31#$31#$1E#$71#$1F +
    #$37#$3F#$3A#$13#$13#$3E#$21#$3F#$70#$7F#$7A#$13#$13#$70#$7F#$7E +
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$38#$00;

  CBlackWhite =
        #$70#$70#$78#$7F#$07#$07#$0F#$07#$0F#$07#$70#$70#$07#$70#$0F +
    #$07#$0F#$07#$70#$70#$07#$70#$0F#$70#$7F#$7F#$70#$07#$70#$07#$0F +
    #$70#$7F#$7F#$70#$07#$70#$70#$7F#$7F#$07#$0F#$0F#$78#$0F#$78#$07 +
    #$0F#$0F#$0F#$70#$0F#$07#$70#$70#$70#$07#$70#$0F#$07#$07#$78#$00;

  CMonochrome =
        #$70#$07#$07#$0F#$70#$70#$70#$07#$0F#$07#$70#$70#$07#$70#$00 +
    #$07#$0F#$07#$70#$70#$07#$70#$00#$70#$70#$70#$07#$07#$70#$07#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00;

  { Turbo Vision 2.0 Color Palettes }

  CAppColor =
        #$71#$70#$78#$74#$20#$28#$24#$17#$1F#$1A#$31#$31#$1E#$71#$1F +
    #$37#$3F#$3A#$13#$13#$3E#$21#$3F#$70#$7F#$7A#$13#$13#$70#$7F#$7E +
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$17#$1F#$1A#$71#$71#$1E#$17#$1F#$1E#$20#$2B#$2F#$78#$2E#$10#$30 +
    #$3F#$3E#$70#$2F#$7A#$20#$12#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$37#$3F#$3A#$13#$13#$3E#$30#$3F#$3E#$20#$2B#$2F#$78#$2E#$30#$70 +
    #$7F#$7E#$1F#$2F#$1A#$20#$32#$31#$71#$70#$2F#$7E#$71#$13#$38#$00;

  CAppBlackWhite =
        #$70#$70#$78#$7F#$07#$07#$0F#$07#$0F#$07#$70#$70#$07#$70#$0F +
    #$07#$0F#$07#$70#$70#$07#$70#$0F#$70#$7F#$7F#$70#$07#$70#$07#$0F +
    #$70#$7F#$7F#$70#$07#$70#$70#$7F#$7F#$07#$0F#$0F#$78#$0F#$78#$07 +
    #$0F#$0F#$0F#$70#$0F#$07#$70#$70#$70#$07#$70#$0F#$07#$07#$78#$00 +
    #$07#$0F#$0F#$07#$70#$07#$07#$0F#$0F#$70#$78#$7F#$08#$7F#$08#$70 +
    #$7F#$7F#$7F#$0F#$70#$70#$07#$70#$70#$70#$07#$7F#$70#$07#$78#$00 +
    #$70#$7F#$7F#$70#$07#$70#$70#$7F#$7F#$07#$0F#$0F#$78#$0F#$78#$07 +
    #$0F#$0F#$0F#$70#$0F#$07#$70#$70#$70#$07#$70#$0F#$07#$07#$78#$00;

  CAppMonochrome =
        #$70#$07#$07#$0F#$70#$70#$70#$07#$0F#$07#$70#$70#$07#$70#$00 +
    #$07#$0F#$07#$70#$70#$07#$70#$00#$70#$70#$70#$07#$07#$70#$07#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00;

{ TBackground palette }

  CBackground = #1;

type

{ TBackground object }

  PBackground = ^TBackground;
  TBackground = object(TView)
    Pattern: Char;
    constructor Init(var Bounds: TRect; APattern: Char);
    constructor Load(var S: TStream);
    procedure Draw; virtual;
    function GetPalette: PPalette; virtual;
    procedure Store(var S: TStream);
  end;

{ TDesktop object }

  PDesktop = ^TDesktop;
  TDesktop = object(TGroup)
    Background: PBackground;
    TileColumnsFirst: Boolean;
    constructor Init(var Bounds: TRect);
    constructor Load(var S: TStream);
    procedure Cascade(var R: TRect);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitBackground; virtual;
    procedure Store(var S: TStream);
    procedure Tile(var R: TRect);
    procedure TileError; virtual;
  end;

{ TProgram object }

  { Palette layout }
  {     1 = TBackground }
  {  2- 7 = TMenuView and TStatusLine }
  {  8-15 = TWindow(Blue) }
  { 16-23 = TWindow(Cyan) }
  { 24-31 = TWindow(Gray) }
  { 32-63 = TDialog }

  PProgram = ^TProgram;
  TProgram = object(TGroup)
    constructor Init;
    destructor Done; virtual;
    function CanMoveFocus: Boolean;
    function ExecuteDialog(P: PDialog; Data: Pointer): Word;
    procedure GetEvent(var Event: TEvent); virtual;
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Idle; virtual;
    procedure InitDesktop; virtual;
    procedure InitMenuBar; virtual;
    procedure InitScreen; virtual;
    procedure DoneScreen; virtual;
    procedure InitStatusLine; virtual;
    function InsertWindow(P: PWindow): PWindow;
    procedure OutOfMemory; virtual;
    procedure PutEvent(var Event: TEvent); virtual;
    procedure Run; virtual;
    procedure SetScreenMode(Mode: Word);
    procedure SetScreenVideoMode(const Mode: TVideoMode);
    function ValidView(P: PView): PView;
  end;

{ TApplication object }

  PApplication = ^TApplication;
  TApplication = object(TProgram)
    constructor Init;
    destructor Done; virtual;
    procedure Cascade;
    procedure DosShell;
    procedure GetTileRect(var R: TRect); virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Tile;
    procedure WriteShellMsg; virtual;
  end;


{ Standard menus and status lines }

function StdStatusKeys(Next: PStatusItem): PStatusItem;

function StdFileMenuItems(Next: PMenuItem): PMenuItem;
function StdEditMenuItems(Next: PMenuItem): PMenuItem;
function StdWindowMenuItems(Next: PMenuItem): PMenuItem;

{ App registration procedure }

procedure RegisterApp;

const

{ Public variables }

  Application: PProgram = nil;
  Desktop: PDesktop = nil;
  StatusLine: PStatusLine = nil;
  MenuBar: PMenuView = nil;
  AppPalette: Integer = apColor;

{ Stream registration records }

  RBackground: TStreamRec = (
    ObjType: 30;
    VmtLink: Ofs(TypeOf(TBackground)^);
    Load: @TBackground.Load;
    Store: @TBackground.Store);

  RDesktop: TStreamRec = (
    ObjType: 31;
    VmtLink: Ofs(TypeOf(TDesktop)^);
    Load: @TDesktop.Load;
    Store: @TDesktop.Store);


implementation

const
{ Private variables }
  Pending: TEvent = (What: evNothing);


{ TBackground }

constructor TBackground.Init(var Bounds: TRect; APattern: Char);
begin
  TView.Init(Bounds);
  GrowMode := gfGrowHiX + gfGrowHiY;
  Pattern := APattern;
end;


constructor TBackground.Load(var S: TStream);
begin
  TView.Load(S);
  S.Read(Pattern, SizeOf(Pattern));
end;


procedure TBackground.Draw;
var
  B: TDrawBuffer;
begin
  MoveChar(B, Pattern, GetColor($01), Size.X);
  WriteLine(0, 0, Size.X, Size.Y, B);
end;


function TBackground.GetPalette: PPalette;
const
  P: string = CBackground;
begin
  GetPalette := @P;
end;


procedure TBackground.Store(var S: TStream);
begin
  TView.Store(S);
  S.Write(Pattern, SizeOf(Pattern));
end;


{ TDesktop object }

constructor TDesktop.Init(var Bounds: TRect);
begin
  inherited Init(Bounds);
  GrowMode := gfGrowHiX + gfGrowHiY;
  InitBackground;
  if Background <> nil then
   Insert(Background);
end;


constructor TDesktop.Load(var S: TStream);
begin
  inherited Load(S);
  GetSubViewPtr(S, Background);
  S.Read(TileColumnsFirst, SizeOf(TileColumnsFirst));
end;


function Tileable(P: PView): Boolean;
begin
  Tileable := (P^.Options and ofTileable <> 0) and (P^.State and sfVisible <> 0);
end;


procedure TDesktop.Cascade(var R: TRect);
var
  CascadeNum: Sw_Integer;
  LastView: PView;
  Min, Max: TPoint;

  procedure DoCount(P: PView);{$IFDEF PPC_BP}far;{$ENDIF}
  begin
    if Tileable(P) then
    begin
      Inc(CascadeNum);
      LastView := P;
    end;
  end;

  procedure DoCascade(P: PView);{$IFDEF PPC_BP}far;{$ENDIF}
  var
    NR: TRect;
  begin
    if Tileable(P) and (CascadeNum >= 0) then
    begin
      NR.Copy(R);
      Inc(NR.A.X, CascadeNum); Inc(NR.A.Y, CascadeNum);
      P^.Locate(NR);
      Dec(CascadeNum);
    end;
  end;

begin
  CascadeNum := 0;
  ForEach(@DoCount);
  if CascadeNum > 0 then
  begin
    LastView^.SizeLimits(Min, Max);
    if (Min.X > R.B.X - R.A.X - CascadeNum) or
       (Min.Y > R.B.Y - R.A.Y - CascadeNum) then TileError
    else
    begin
      Dec(CascadeNum);
      Lock;
      ForEach(@DoCascade);
      Unlock;
    end;
  end;
end;


procedure TDesktop.HandleEvent(var Event: TEvent);
begin
  TGroup.HandleEvent(Event);
  if Event.What = evCommand then
  begin
    case Event.Command of
      cmNext: FocusNext(False);
      cmPrev:
        if Valid(cmReleasedFocus) then
          Current^.PutInFrontOf(Background);
    else
      Exit;
    end;
    ClearEvent(Event);
  end;
end;


procedure TDesktop.InitBackground;
var
  R: TRect;
begin
  GetExtent(R);
  New(Background, Init(R, #176));
end;


function ISqr(X: Sw_Integer): Sw_Integer;
var
  Root: Sw_Integer;
begin
  Root := 0;
  while (Root * Root < X) do
    Inc(Root);
  ISqr := Root - 1;
end;


procedure MostEqualDivisors(N: Sw_Integer; var X, Y: Sw_Integer; FavorY: Boolean);
var
  I: Sw_Integer;
begin
  I := ISqr(N);
  if (I=0) then
   begin
     X:=0;
     Y:=0;
     exit;
   end;
  if ((N mod I) <> 0) then
    if (N mod (I+1)) = 0 then Inc(I);
  if I < (N div I) then I := N div I;
  if FavorY then
  begin
    X := N div I;
    Y := I;
  end
  else
  begin
    Y := N div I;
    X := I;
  end;
end;


procedure TDesktop.Store(var S: TStream);
begin
  inherited Store(S);
  PutSubViewPtr(S, Background);
  S.Write(TileColumnsFirst, SizeOf(TileColumnsFirst));
end;

procedure TDesktop.Tile(var R: TRect);
var
  NumCols, NumRows, NumTileable, LeftOver, TileNum: Sw_Integer;

  procedure DoCountTileable(P: PView);{$IFDEF PPC_BP}far;{$ENDIF}
  begin
    if Tileable(P) then Inc(NumTileable);
  end;

  function DividerLoc(Lo, Hi, Num, Pos: Sw_Integer): Sw_Integer;
  begin
    DividerLoc := LongDiv(LongMul(Hi - Lo, Pos), Num) + Lo;
  end;

  procedure CalcTileRect(Pos: Sw_Integer; var NR: TRect);
  var
    X,Y,D: Sw_Integer;
  begin
    D := (NumCols - LeftOver) * NumRows;
    if Pos < D then
    begin
      X := Pos div NumRows;
      Y := Pos mod NumRows;
    end else
    begin
      X := (Pos - D) div (NumRows + 1) + (NumCols - LeftOver);
      Y := (Pos - D) mod (NumRows + 1);
    end;
    NR.A.X := DividerLoc(R.A.X, R.B.X, NumCols, X);
    NR.B.X := DividerLoc(R.A.X, R.B.X, NumCols, X+1);
    if Pos >= D then
    begin
      NR.A.Y := DividerLoc(R.A.Y, R.B.Y, NumRows+1, Y);
      NR.B.Y := DividerLoc(R.A.Y, R.B.Y, NumRows+1, Y+1);
    end else
    begin
      NR.A.Y := DividerLoc(R.A.Y, R.B.Y, NumRows, Y);
      NR.B.Y := DividerLoc(R.A.Y, R.B.Y, NumRows, Y+1);
    end;
  end;

  procedure DoTile(P: PView);{$IFDEF PPC_BP}far;{$ENDIF}
  var
    R: TRect;
  begin
    if Tileable(P) then
    begin
      CalcTileRect(TileNum, R);
      P^.Locate(R);
      Dec(TileNum);
    end;
  end;

begin
  NumTileable := 0;
  ForEach(@DoCountTileable);
  if NumTileable > 0 then
  begin
    MostEqualDivisors(NumTileable, NumCols, NumRows, not TileColumnsFirst);
    if (NumCols=0) or (NumRows=0) or
       ((R.B.X - R.A.X) div NumCols = 0) or
       ((R.B.Y - R.A.Y) div NumRows = 0) then
      TileError
    else
      begin
        LeftOver := NumTileable mod NumCols;
        TileNum := NumTileable-1;
        Lock;
        ForEach(@DoTile);
        Unlock;
      end;
  end;
end;

procedure TDesktop.TileError;
begin
end;


{****************************************************************************
                                 TProgram
****************************************************************************}

constructor TProgram.Init;
var
  R : TRect;
begin
  Application := @Self;
  Drivers.InitVideo;
  R.Assign(0, 0, ScreenWidth, ScreenHeight);
  TGroup.Init(R);
  InitScreen;
  State := sfVisible + sfSelected + sfFocused + sfModal + sfExposed;
  Options := 0;
  InitDesktop;
  InitStatusLine;
  InitMenuBar;
  if Desktop <> nil then
   Insert(Desktop);
  if StatusLine <> nil then
   Insert(StatusLine);
  if MenuBar <> nil then
   Insert(MenuBar);
end;


destructor TProgram.Done;
begin
  if Desktop <> nil then
   Dispose(Desktop, Done);
  if MenuBar <> nil then
   Dispose(MenuBar, Done);
  if StatusLine <> nil then
   Dispose(StatusLine, Done);
  Application := nil;
  inherited Done;
end;


function TProgram.CanMoveFocus: Boolean;
begin
  CanMoveFocus := Desktop^.Valid(cmReleasedFocus);
end;


function TProgram.ExecuteDialog(P: PDialog; Data: Pointer): Word;
var
  C: Word;
begin
  ExecuteDialog := cmCancel;
  if ValidView(P) <> nil then
  begin
    if Data <> nil then
     P^.SetData(Data^);
    C := Desktop^.ExecView(P);
    if (C <> cmCancel) and (Data <> nil) then
     P^.GetData(Data^);
    Dispose(P, Done);
    ExecuteDialog := C;
  end;
end;


procedure TProgram.GetEvent(var Event: TEvent);

  function ContainsMouse(P: PView): Boolean;{$IFDEF PPC_BP}far;{$ENDIF}
  begin
    ContainsMouse := (P^.State and sfVisible <> 0) and P^.MouseInView(Event.Where);
  end;

begin
  if Pending.What <> evNothing then
  begin
    Event := Pending;
    Pending.What := evNothing;
  end else
  begin
    GetMouseEvent(Event);
    if Event.What = evNothing then
    begin
      GetKeyEvent(Event);
      if Event.What = evNothing then
        begin
           Idle;
{$ifdef OS_WINDOWS}
           Sleep(50);
{$endif OS_WINDOWS}
        end;
    end;
  end;
  if StatusLine <> nil then
    if (Event.What and evKeyDown <> 0) or
      (Event.What and evMouseDown <> 0) and
      (FirstThat(@ContainsMouse) = PView(StatusLine)) then
      StatusLine^.HandleEvent(Event);
end;


function TProgram.GetPalette: PPalette;
const
  P: array[apColor..apMonochrome] of string[Length(CAppColor)] =
    (CAppColor, CAppBlackWhite, CAppMonochrome);
begin
  GetPalette := @P[AppPalette];
end;


procedure TProgram.HandleEvent(var Event: TEvent);
var
  C : Char;
begin
  if Event.What = evKeyDown then
  begin
    C := GetAltChar(Event.KeyCode);
    if (C >= '1') and (C <= '9') then
      if Message(Desktop, evBroadCast, cmSelectWindowNum,
        Pointer(Byte(C) - $30)) <> nil then ClearEvent(Event);
  end;
  TGroup.HandleEvent(Event);
  if Event.What = evCommand then
    if Event.Command = cmQuit then
    begin
      EndModal(cmQuit);
      ClearEvent(Event);
    end;
end;


procedure TProgram.Idle;
begin
  if StatusLine <> nil then
    StatusLine^.Update;
  if CommandSetChanged then
   begin
     Message(@Self, evBroadcast, cmCommandSetChanged, nil);
     CommandSetChanged := False;
   end;
end;


procedure TProgram.InitDesktop;
var
  R: TRect;
begin
  GetExtent(R);
  Inc(R.A.Y);
  Dec(R.B.Y);
  New(Desktop, Init(R));
end;


procedure TProgram.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, nil));
end;


procedure TProgram.InitScreen;
begin
  Drivers.InitVideo;
{$ifdef FV20}
  if Lo(ScreenMode) <> smMono then
   begin
     if ScreenMode and smFont8x8 <> 0 then
      ShadowSize.X := 1
     else
      ShadowSize.X := 2;
     ShadowSize.Y := 1;
     ShowMarkers := False;
     if Lo(ScreenMode) = smBW80 then
      AppPalette := apBlackWhite
     else
      AppPalette := apColor;
   end
  else
   begin
     ShadowSize.X := 0;
     ShadowSize.Y := 0;
     ShowMarkers := True;
     AppPalette := apMonochrome;
   end;
{$else FV20}
  { the orginal code can't be used here because of the limited
    video unit capabilities, the mono modus can't be handled
  }
  if (ScreenMode.Col div ScreenMode.Row<2) then
    ShadowSize.X := 1
  else
    ShadowSize.X := 2;

  ShadowSize.Y := 1;
  ShowMarkers := False;
  if ScreenMode.color then
    AppPalette := apColor
  else
    AppPalette := apBlackWhite;
{$endif FV20}
  Buffer := Views.PVideoBuf(VideoBuf);
end;


procedure TProgram.DoneScreen;
begin
  DoneVideo;
  Buffer:=nil;
end;


procedure TProgram.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey(Labels^.Get(slAltXExit), kbAltX, cmQuit,
      StdStatusKeys(nil)), nil)));
end;


function TProgram.InsertWindow(P: PWindow): PWindow;
begin
  InsertWindow := nil;
  if ValidView(P) <> nil then
    if CanMoveFocus then
    begin
      Desktop^.Insert(P);
      InsertWindow := P;
    end
    else
      Dispose(P, Done);
end;


procedure TProgram.OutOfMemory;
begin
end;


procedure TProgram.PutEvent(var Event: TEvent);
begin
  Pending := Event;
end;


procedure TProgram.Run;
begin
  Execute;
end;


procedure TProgram.SetScreenMode(Mode: Word);
var
  R: TRect;
begin
  HideMouse;
  DoneMemory;
  InitMemory;
  InitScreen;
  Buffer := Views.PVideoBuf(VideoBuf);
  R.Assign(0, 0, ScreenWidth, ScreenHeight);
  ChangeBounds(R);
  ShowMouse;
end;

procedure TProgram.SetScreenVideoMode(const Mode: TVideoMode);
var
  R: TRect;
begin
  DoneMouse;
  DoneMemory;
  ScreenMode:=Mode;
  Video.SetVideoMode(Mode);
  InitMouse;
  InitMemory;
  InitScreen;
  Buffer := Views.PVideoBuf(VideoBuf);
  R.Assign(0, 0, ScreenWidth, ScreenHeight);
  ChangeBounds(R);
  ShowMouse;
end;


function TProgram.ValidView(P: PView): PView;
begin
  ValidView := nil;
  if P <> nil then
  begin
    if LowMemory then
    begin
      Dispose(P, Done);
      OutOfMemory;
      Exit;
    end;
    if not P^.Valid(cmValid) then
    begin
      Dispose(P, Done);
      Exit;
    end;
    ValidView := P;
  end;
end;


{****************************************************************************
                            TApplication
****************************************************************************}

constructor TApplication.Init;
begin
  InitMemory;
  InitEvents;
  InitSysError;
  InitHistory;
  InitResource;
  InitMsgBox;
  TProgram.Init;
{ init mouse and cursor }
  Video.SetCursorType(crHidden);
  Mouse.SetMouseXY(1,1);
end;


destructor TApplication.Done;
begin
{ fix cursor to be visible always }
  Video.SetCursorType(crUnderline);
  TProgram.Done;
  DoneMsgBox;
  DoneResource;
  DoneHistory;
  DoneSysError;
  DoneEvents;
  DoneMemory;
end;


procedure TApplication.Cascade;
var
  R: TRect;
begin
  GetTileRect(R);
  if Desktop <> nil then
    Desktop^.Cascade(R);
end;


procedure TApplication.DosShell;
begin
  DoneSysError;
  DoneEvents;
  DoneScreen;
  DoneDosMem;
  WriteShellMsg;
  SwapVectors;
  Exec(GetEnv('COMSPEC'), '');
  SwapVectors;
  InitDosMem;
  InitScreen;
  InitEvents;
  InitSysError;
  Redraw;
end;


procedure TApplication.GetTileRect(var R: TRect);
begin
  Desktop^.GetExtent(R);
end;

procedure TApplication.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cmTile: Tile;
          cmCascade: Cascade;
          cmDosShell: DosShell;
        else
          Exit;
        end;
        ClearEvent(Event);
      end;
  end;
end;


procedure TApplication.Tile;
var
  R: TRect;
begin
  GetTileRect(R);
  if Desktop <> nil then
   Desktop^.Tile(R);
end;


procedure TApplication.WriteShellMsg;
begin
  PrintStr(Strings^.Get(sTypeExitOnReturn));
end;


{ App registration procedure }

procedure RegisterApp;
begin
  RegisterType(RBackground);
  RegisterType(RDesktop);
end;


{ Standard menus and status lines }

function StdStatusKeys(Next: PStatusItem): PStatusItem;
begin
  StdStatusKeys :=
    NewStatusKey('', kbAltX, cmQuit,
    NewStatusKey('', kbF10, cmMenu,
    NewStatusKey('', kbAltF3, cmClose,
    NewStatusKey('', kbF5, cmZoom,
    NewStatusKey('', kbCtrlF5, cmResize,
    NewStatusKey('', kbF6, cmNext,
    NewStatusKey('', kbShiftF6, cmPrev,
    Next)))))));
end;


function StdFileMenuItems(Next: PMenuItem): PMenuItem;
begin
  StdFileMenuItems :=
    NewItem(Labels^.Get(slNew), '', kbNoKey, cmNew, hcNew,
    NewItem(Labels^.Get(slOpenDots), Labels^.Get(slF3), kbF3, cmOpen, hcOpen,
    NewItem(Labels^.Get(slSave), Labels^.Get(slF2), kbF2, cmSave, hcSave,
    NewItem(Labels^.Get(slSaveAs), '', kbNoKey, cmSaveAs, hcSaveAs,
    NewItem(Labels^.Get(slSaveAll), '', kbNoKey, cmSaveAll, hcSaveAll,
    NewLine(
    NewItem(Labels^.Get(slChangeDir), '', kbNoKey, cmChangeDir, hcChangeDir,
    NewItem(Labels^.Get(slDOSShell), '', kbNoKey, cmDosShell, hcDosShell,
    NewItem(Labels^.Get(slExit),Labels^.Get(slAltX), kbAltX, cmQuit, hcExit,
    Next)))))))));
end;


function StdEditMenuItems(Next: PMenuItem): PMenuItem;
begin
  StdEditMenuItems :=
    NewItem(Labels^.Get(slUndo), '', kbAltBack, cmUndo, hcUndo,
    NewLine(
    NewItem(Labels^.Get(slCut), Labels^.Get(slShiftDel), kbShiftDel, cmCut, hcCut,
    NewItem(Labels^.Get(slCopy), Labels^.Get(slCtrlIns), kbCtrlIns, cmCopy, hcCopy,
    NewItem(Labels^.Get(slPaste), Labels^.Get(slShiftIns), kbShiftIns, cmPaste, hcPaste,
    NewItem(Labels^.Get(slClear), Labels^.Get(slCtrlDel), kbCtrlDel, cmClear, hcClear,
    Next))))));
end;


function StdWindowMenuItems(Next: PMenuItem): PMenuItem;
begin
  StdWindowMenuItems :=
    NewItem(Labels^.Get(slTile), '', kbNoKey, cmTile, hcTile,
    NewItem(Labels^.Get(slCascade), '', kbNoKey, cmCascade, hcCascade,
    NewItem(Labels^.Get(slCloseAll), '', kbNoKey, cmCloseAll, hcCloseAll,
    NewLine(
    NewItem(Labels^.Get(slSizeMove),Labels^.Get(slCtrlF5), kbCtrlF5, cmResize, hcResize,
    NewItem(Labels^.Get(slZoom), Labels^.Get(slF5), kbF5, cmZoom, hcZoom,
    NewItem(Labels^.Get(slNext), Labels^.Get(slF6), kbF6, cmNext, hcNext,
    NewItem(Labels^.Get(slPrevious), Labels^.Get(slShiftF6), kbShiftF6, cmPrev, hcPrev,
    NewItem(Labels^.Get(slClose), Labels^.Get(slAltF3), kbAltF3, cmClose, hcClose,
    Next)))))))));
end;


end.
