{ Free Vision Help Context Unit

  Programmer: Brad Williams
  BitSoft Development, L.L.C.
  Copyright (c) 1996 }

unit HelpCtx;

{
  The HelpCtx unit declares standard help contexts used in FreeVision.  By
  placing all help contexts in one unit, duplicate help contexts are more
  easily prevented
}

interface

const

  hcNoContext = 0;
  hcDragging = 1;
  hcOk = 2;
  hcCancel = 3;
  hcEdit   = 4;
  hcDelete = 5;
  hcInsert = 6;

    { App Unit }
  hcNew = 65281;        hcFileNew = hcNew;
  hcOpen = 65282;       hcFileOpen = hcOpen;
  hcSave = 65283;       hcFileSave = hcSave;
  hcSaveAs = 65284;     hcFileSaveAs = hcSaveAs;
  hcSaveAll = 65285;    hcFileSaveAll = hcSaveAll;
  hcChangeDir = 65286;  hcFileChangeDir = hcChangeDir;
  hcDosShell = 65287;   hcFileDOSShell = hcDosShell;
  hcExit = 65288;       hcFileExit = hcExit;
  hcEditMenu = 65289;
  hcHelpMenu = 65291;
  hcHelpContents = 65292;
  hcHelpIndex = 65293;
  hcHelpTopic = 65294;
  hcHelpPrev = 65295;
  hcHelpUsingHelp = 65296;
  hcHelpAbout = 65297;
  hcWindowMenu = 65298;
  hcUndo         = $FF10;
  hcCut          = $FF11;
  hcCopy         = $FF12;
  hcPaste        = $FF13;
  hcClear        = $FF14;
  hcTile         = $FF20;
  hcCascade      = $FF21;
  hcCloseAll     = $FF22;
  hcResize       = $FF23;
  hcZoom         = $FF24;
  hcNext         = $FF25;
  hcPrev         = $FF26;
  hcClose        = $FF27;
  hcFileMenu     = 65320;
  hcSearchAndReplace =65325;

    { Editors Unit }
  hcFile_Menu            = 2100;
{ hcOpen                 = 2101; }
{ hcNew                  = 2102; }
{ hcSave                 = 2103; }
  hcSaveDone             = 2104;
{ hcSaveAs               = 2105; }
{ hcChangeDir            = 2106; }
{ hcShellToDos           = 2107; }
{ hcExit                 = 2108; }
  hcFile_Menu_Items      = hcExit;

  hcEdit_Menu            = 2200;
{ hcUndo                 = 2201; }
{ hcCopy                 = 2202; }
{ hcCut                  = 2203; }
{ hcPaste                = 2204; }
  hcClipboard            = 2205;
{ hcClear                = 2206; }
  hcSpellCheck           = 2207;
  hcEdit_Menu_Items      = hcSpellCheck;

  hcSearch_Menu          = 2300;
  hcFind                 = 2301;
  hcReplace              = 2302;
  hcAgain                = 2303;
  hcSearch_Menu_Items    = hcAgain;

  hcWindows_Menu         = 2400;
{  hcResize               = 2401; }
{  hcZoom                 = 2402; }
{  hcPrev                 = 2403; }
{  hcNext                 = 2404; }
{  hcClose                = 2405; }
{  hcTile                 = 2406; }
{  hcCascade              = 2407; }
  hcWindows_Menu_Items   = hcCascade;

  hcDesktop_Menu         = 2500;
  hcLoadDesktop          = 2501;
  hcSaveDesktop          = 2502;
  hcToggleVideo          = 2503;
  hcDesktop_Menu_Items   = hcToggleVideo;

  hcMisc_Commands        = 2600;
  hckbShift              = 2601;
  hckbCtrl               = 2602;
  hckbAlt                = 2603;
  hcMisc_Items           = hckbAlt;

  hcEditor_Commands      = 2700;
  hcCursor               = 2701;
  hcDeleting             = 2702;
  hcFormatting           = 2703;
  hcMarking              = 2704;
  hcMoving               = 2705;
  hcSaving               = 2706;
  hcSelecting            = 2707;
  hcTabbing              = 2708;
  hcBackSpace            = 2709;
  hcCenterText           = 2710;
  hcCharLeft             = 2711;
  hcCharRight            = 2712;
  hcDelChar              = 2713;
  hcDelEnd               = 2714;
  hcDelLine              = 2715;
  hcDelStart             = 2716;
  hcDelWord              = 2717;
  hcEndPage              = 2718;
  hcHideSelect           = 2719;
  hcHomePage             = 2720;
  hcIndentMode           = 2721;
  hcInsertLine           = 2722;
  hcInsMode              = 2723;
  hcJumpLine             = 2724;
  hcLineDown             = 2725;
  hcLineEnd              = 2726;
  hcLineStart            = 2727;
  hcLineUp               = 2728;
  hcNewLine              = 2729;
  hcPageDown             = 2730;
  hcPageUp               = 2731;
  hcReformDoc            = 2732;
  hcReformPara           = 2733;
  hcRightMargin          = 2734;
  hcScrollDown           = 2735;
  hcScrollUp             = 2736;
  hcSearchAgain          = 2737;
  hcSelectWord           = 2738;
  hcSetTabs              = 2739;
  hcStartSelect          = 2740;
  hcTabKey               = 2741;
  hcTextEnd              = 2742;
  hcTextStart            = 2743;
  hcWordLeft             = 2744;
  hcWordRight            = 2745;
  hcWordWrap             = 2746;

  hcJMarker_Menu         = 2750;
  hcJumpMark1            = 2751;
  hcJumpMark2            = 2752;
  hcJumpMark3            = 2753;
  hcJumpMark4            = 2754;
  hcJumpMark5            = 2755;
  hcJumpMark6            = 2756;
  hcJumpMark7            = 2757;
  hcJumpMark8            = 2758;
  hcJumpMark9            = 2759;
  hcJumpMark0            = 2760;
  hcJMarker_Menu_Items   = 2761;

  hcSMarker_Menu         = 2770;
  hcSetMark1             = 2771;
  hcSetMark2             = 2772;
  hcSetMark3             = 2773;
  hcSetMark4             = 2774;
  hcSetMark5             = 2775;
  hcSetMark6             = 2776;
  hcSetMark7             = 2777;
  hcSetMark8             = 2778;
  hcSetMark9             = 2779;
  hcSetMark0             = 2780;
  hcSMarker_Menu_Items   = 2781;

  hcEditor_Items         = hcSMarker_Menu_Items;

  { Dialog }
  hcDialogs              = 2800;
  hcDCancel              = 2801;
  hcDNo                  = 2802;
  hcDOk                  = 2803;
  hcDYes                 = 2804;
  hcDAbout               = 2805;
  hcDDirName             = 2806;
  hcDDirTree             = 2807;
  hcDChDir               = 2808;
  hcDRevert              = 2809;
  hcDName                = 2810;
  hcDFiles               = 2811;
  hcDFindText            = 2812;
  hcDLineNumber          = 2813;
  hcDReformDoc           = 2814;
  hcDReplaceTExt         = 2815;
  hcDRightMargin         = 2816;
  hcDTabStops            = 2817;

  { Checkbox help }
  hcCCaseSensitive       = 2900;
  hcCWholeWords          = 2901;
  hcCPromptReplace       = 2902;
  hcCReplaceAll          = 2903;
  hcCReformCurrent       = 2904;
  hcCReformEntire        = 2905;

  { Glossary }
  Glossary               = 3000;
  GCloseIcon             = 3001;
  GDesktop               = 3002;
  GDialogBox             = 3003;
  GHistoryIcon           = 3004;
  GInputLine             = 3005;
  GMemIndicator          = 3006;
  GMenuBar               = 3007;
  GPulldownMenu          = 3008;
  GResizeCorner          = 3009;
  GSelectedText          = 3010;
  GStatusBar             = 3011;
  GTitleBar              = 3012;
  GWindowBorder          = 3013;
  GZoomIcon              = 3014;
  hcGlossary_Items       = GZoomIcon;

    { INI Unit }
  hcDateFormatDlg = 1;
  hcDateParts = 1;
  hcDateOrder = 1;
  hcTimeFormatDlg = 1;
  hcClockFormatDlg = 1;
  hcClockDateParts = 1;
  hcClockTimeFormat = 1;

  hcListViewer = 1;

    { Options Help Contexts }
  hcConfigMenu          = 100;
  hcConfigColors        = hcConfigMenu + 1;
  hcConfigDate          = hcConfigColors + 1;
  hcConfigEnvironment   = hcConfigDate + 1;
  hcConfigMouse         = hcConfigEnvironment + 1;
  hcConfigOpen          = hcConfigMouse + 1;
  hcConfigSave          = hcConfigOpen + 1;
  hcConfigSaveAs        = hcConfigSave + 1;
  hcConfigTime          = hcConfigSaveAs + 1;
  hcConfigVideo         = hcConfigTime + 1;
  hcConfigDesktopDlg    = hcConfigVideo + 1;
  hcConfigMouseDlg      = hcConfigDesktopDlg + 1;
  hcConfigTimeFormatDlg = hcConfigMouseDlg + 1;
  hcConfigTimeSeparator = hcConfigTimeFormatDlg + 1;
  hcConfigTimeComponents = hcConfigTimeSeparator + 1;
  hcConfigTimeStyle = hcConfigTimeComponents + 1;
  hcConfigClock = hcConfigTimeStyle + 1;
  hcBrowseDir = 1;
  hcBrowseFile = 1;

implementation

begin
end.