PROGRAM TestDrv;

{====Include file to sort compiler platform out =====================}
{$I Platform.inc}
{====================================================================}

{&PMTYPE PM}

USES
     {$IFDEF OS_WINDOWS}
     WinCrt,
     {$ELSE}
     Crt,
     {$ENDIF}
     Drivers;

{ ******************************* REMARK ****************************** }
{   This illustrates how to hook the mouse movement for situations in   }
{   which the user whats to install there own mouse cursor or has to    }
{   install there own cursor such as in SVGA mode. The same hook mode   }
{   is used for showmouseproc and hidemouseproc when the mouse is shown }
{   or hidden using the show mouse or hide mouse calls.                 }
{                                                                       }
{   BIG REMINDER!!! These call backs are in the interrupt handler and   }
{   as DOS is non re-enterant you can not use DOS calls such as reads   }
{   and writes.                                                         }
{ ****************************** END REMARK *** Leon de Boer, 10Sep98 * }

VAR I, J: Integer;

VAR Event: TEvent;
BEGIN
   ClrScr;
   WriteLn('Press "ESC" to exit');
   InitEvents;                                        { Start event drive }
   Repeat
     GetMouseEvent(Event);
     If (Event.What = evNothing) Then GetKeyEvent(Event);
     If (Event.What <> evNothing) Then Begin
       GotoXY(10, 10);
       Write('Event = ', Event.What, '  ');
       GotoXY(10, 11);
       If (Event.What = evKeyDown) Then
         Write('Keycode = ', Event.CharCode, '            ')
         Else Write('Position = ', Event.Where.X,
           ',', Event.Where.Y, '         ');
     End Else Begin
       GotoXY(20, 20);
       Write('MouseInt -> ', I, ',', J, '          ');
     End;
   Until (Event.What=evKeyDown) AND (Event.KeyCode = kbEsc);
   DoneEvents;                                        { Close event drive }
END.
