{
   $Id: gtkcolorsel.pp,v 1.7 1999/05/11 00:38:18 peter Exp $
}

{****************************************************************************
                                 Interface
****************************************************************************}

{$ifdef read_interface}

    type
       PGtkColorSelection = ^TGtkColorSelection;
{$PACKRECORDS 4}
       TGtkColorSelection = record
            vbox : TGtkVBox;
            wheel_area : PGtkWidget;
            value_area : PGtkWidget;
            sample_area : PGtkWidget;
            sample_area_eb : PGtkWidget;
            scales : array[0..7] of PGtkWidget;
            entries : array[0..7] of PGtkWidget;
            opacity_label : PGtkWidget;
            wheel_gc : PGdkGC;
            value_gc : PGdkGC;
            sample_gc : PGdkGC;
            policy : TGtkUpdateType;
            use_opacity : gint;
            timer_active : gint;
            timer_tag : gint;
            values : array[0..7] of gdouble;
            old_values : array[0..7] of gdouble;
            wheel_buf : Pguchar;
            value_buf : Pguchar;
            sample_buf : Pguchar;
         end;

       PGtkColorSelectionClass = ^TGtkColorSelectionClass;
{$PACKRECORDS 4}
       TGtkColorSelectionClass = record
            parent_class : TGtkVBoxClass;
            color_changed : procedure (colorsel:PGtkColorSelection); cdecl;
         end;

       PGtkColorSelectionDialog = ^TGtkColorSelectionDialog;
{$PACKRECORDS 4}
       TGtkColorSelectionDialog = record
            window : TGtkWindow;
            colorsel : PGtkWidget;
            main_vbox : PGtkWidget;
            ok_button : PGtkWidget;
            reset_button : PGtkWidget;
            cancel_button : PGtkWidget;
            help_button : PGtkWidget;
         end;

       PGtkColorSelectionDialogClass = ^TGtkColorSelectionDialogClass;
{$PACKRECORDS 4}
       TGtkColorSelectionDialogClass = record
            parent_class : TGtkWindowClass;
         end;

Type
  GTK_COLOR_SELECTION=PGtkColorSelection;
  GTK_COLOR_SELECTION_CLASS=PGtkColorSelectionClass;

  GTK_COLOR_SELECTION_DIALOG=PGtkColorSelectionDialog;
  GTK_COLOR_SELECTION_DIALOG_CLASS=PGtkColorSelectionDialogClass;

{ ColorSelection }
function  GTK_COLOR_SELECTION_TYPE:TGtkType;cdecl;
function  GTK_IS_COLOR_SELECTION(obj:pointer):boolean;
function  GTK_IS_COLOR_SELECTION_CLASS(klass:pointer):boolean;

function  gtk_color_selection_get_type:TGtkType;cdecl;
function  gtk_color_selection_new:PGtkWidget;cdecl;
procedure gtk_color_selection_set_update_policy(colorsel:PGtkColorSelection; policy:TGtkUpdateType);cdecl;
procedure gtk_color_selection_set_opacity(colorsel:PGtkColorSelection; use_opacity:gint);cdecl;
procedure gtk_color_selection_set_color(colorsel:PGtkColorSelection; color:Pgdouble);cdecl;
procedure gtk_color_selection_get_color(colorsel:PGtkColorSelection; color:Pgdouble);cdecl;

{ ColorSelectionDialog }
function  gtk_color_selection_dialog_get_type:guint;cdecl;
function  gtk_color_selection_dialog_new (title:Pgchar):PGtkWidget;cdecl;

{$endif read_interface}


{****************************************************************************
                              Implementation
****************************************************************************}

{$ifdef read_implementation}

function  GTK_COLOR_SELECTION_TYPE:TGtkType;cdecl;external gtkdll name 'gtk_color_selection_get_type';
function  GTK_IS_COLOR_SELECTION(obj:pointer):boolean;
begin
  GTK_IS_COLOR_SELECTION:=(obj<>nil) and GTK_IS_COLOR_SELECTION_CLASS(PGtkTypeObject(obj)^.klass);
end;
function  GTK_IS_COLOR_SELECTION_CLASS(klass:pointer):boolean;
begin
  GTK_IS_COLOR_SELECTION_CLASS:=(klass<>nil) and (PGtkTypeClass(klass)^.thetype=GTK_COLOR_SELECTION_TYPE);
end;

function  gtk_color_selection_get_type:TGtkType;cdecl;external gtkdll name 'gtk_color_selection_get_type';
procedure gtk_color_selection_set_update_policy(colorsel:PGtkColorSelection; policy:TGtkUpdateType);cdecl;external gtkdll name 'gtk_color_selection_set_update_policy';
procedure gtk_color_selection_set_opacity(colorsel:PGtkColorSelection; use_opacity:gint);cdecl;external gtkdll name 'gtk_color_selection_set_opacity';
procedure gtk_color_selection_set_color(colorsel:PGtkColorSelection; color:Pgdouble);cdecl;external gtkdll name 'gtk_color_selection_set_color';
procedure gtk_color_selection_get_color(colorsel:PGtkColorSelection; color:Pgdouble);cdecl;external gtkdll name 'gtk_color_selection_get_color';
function  gtk_color_selection_new : PGtkWidget;cdecl;external gtkdll name 'gtk_color_selection_new';
function  gtk_color_selection_dialog_get_type:guint;cdecl;external gtkdll name 'gtk_color_selection_dialog_get_type';
function  gtk_color_selection_dialog_new (title:Pgchar):PGtkWidget;cdecl;external gtkdll name 'gtk_color_selection_dialog_new';

{$endif read_implementation}


{
  $Log: gtkcolorsel.pp,v $
  Revision 1.7  1999/05/11 00:38:18  peter
    * win32 fixes

  Revision 1.6  1999/05/10 15:19:06  peter
    * cdecl fixes

  Revision 1.5  1999/05/07 17:40:16  peter
    * more updates

  Revision 1.4  1998/11/09 10:09:41  peter
    + C type casts are now correctly handled

  Revision 1.3  1998/10/21 20:22:16  peter
    * cdecl, packrecord fixes (from the gtk.tar.gz)
    * win32 support
    * gtk.pp,gdk.pp for an all in one unit

}

