{
   $Id: gtkentry.pp,v 1.7 1999/05/11 00:38:29 peter Exp $
}

{****************************************************************************
                                 Interface
****************************************************************************}

{$ifdef read_interface}

  type
     PGtkEntry = ^TGtkEntry;
{$PACKRECORDS 4}
     TGtkEntry = record
          editable : TGtkEditable;
          text_area : PGdkWindow;
          backing_pixmap : PGdkPixmap;
          cursor : PGdkCursor;
{$ifdef GTK10}
          text : Pgchar;
{$else}
          text : PGdkWChar;
{$endif}
          text_size : guint16;
          text_length : guint16;
          text_max_length : guint16;
          scroll_offset : gint;
          flag0 : word;
          timer : guint32;
          button : guint;
{$ifdef GTK10}
          nchars : guint;
          char_pos : Pguint16;
{$endif}
          char_offset : Pgint;
{$ifndef GTK10}
          text_mb : Pgchar;
          flag1 : word;
{$endif}
       end;

  const
     bm_TGtkEntry_visible = $1;
     bp_TGtkEntry_visible = 0;
{$ifndef GTK10}
     bm_TGtkEntry_text_mb_dirty = $1;
     bp_TGtkEntry_text_mb_dirty = 0;
     bm_TGtkEntry_use_wchar = $2;
     bp_TGtkEntry_use_wchar = 1;
{$endif}
function  visible(var a : TGtkEntry) : guint;
procedure set_visible(var a : TGtkEntry; __visible : guint);
{$ifndef GTK10}
function  text_mb_dirty(var a : TGtkEntry) : guint;
procedure set_text_mb_dirty(var a : TGtkEntry; __text_mb_dirty : guint);
function  use_wchar(var a : TGtkEntry) : guint;
procedure set_use_wchar(var a : TGtkEntry; __use_wchar : guint);
{$endif}

  type
     PGtkEntryClass = ^TGtkEntryClass;
{$PACKRECORDS 4}
     TGtkEntryClass = record
          parent_class : TGtkEditableClass;
       end;

Type
  GTK_ENTRY=PGtkEntry;
  GTK_ENTRY_CLASS=PGtkEntryClass;

function  GTK_ENTRY_TYPE:TGtkType;cdecl;
function  GTK_IS_ENTRY(obj:pointer):boolean;
function  GTK_IS_ENTRY_CLASS(klass:pointer):boolean;

function  gtk_entry_get_type:TGtkType;cdecl;
function  gtk_entry_new :PGtkWidget;cdecl;
function  gtk_entry_new_with_max_length (max:guint16):PGtkWidget;cdecl;
procedure gtk_entry_set_text(entry:PGtkEntry; text:Pgchar);cdecl;
procedure gtk_entry_append_text(entry:PGtkEntry; text:Pgchar);cdecl;
procedure gtk_entry_prepend_text(entry:PGtkEntry; text:Pgchar);cdecl;
procedure gtk_entry_set_position(entry:PGtkEntry; position:gint);cdecl;
function  gtk_entry_get_text (entry:PGtkEntry):Pgchar;cdecl;
procedure gtk_entry_select_region(entry:PGtkEntry; start:gint; theend:gint);cdecl;
procedure gtk_entry_set_visibility(entry:PGtkEntry; visible:gboolean);cdecl;
procedure gtk_entry_set_editable(entry:PGtkEntry; editable:gboolean);cdecl;
procedure gtk_entry_set_max_length(entry:PGtkEntry; max:guint16);cdecl;

{$endif read_interface}


{****************************************************************************
                              Implementation
****************************************************************************}

{$ifdef read_implementation}

function  visible(var a : TGtkEntry) : guint;
    begin
       visible:=(a.flag0 and bm_TGtkEntry_visible) shr bp_TGtkEntry_visible;
    end;

procedure set_visible(var a : TGtkEntry; __visible : guint);
    begin
       a.flag0:=a.flag0 or ((__visible shl bp_TGtkEntry_visible) and bm_TGtkEntry_visible);
    end;

{$ifndef GTK10}
function  text_mb_dirty(var a : TGtkEntry) : guint;
    begin
       text_mb_dirty:=(a.flag1 and bm_TGtkEntry_text_mb_dirty) shr bp_TGtkEntry_text_mb_dirty;
    end;

procedure set_text_mb_dirty(var a : TGtkEntry; __text_mb_dirty : guint);
    begin
       a.flag1:=a.flag1 or ((__text_mb_dirty shl bp_TGtkEntry_text_mb_dirty) and bm_TGtkEntry_text_mb_dirty);
    end;

function  use_wchar(var a : TGtkEntry) : guint;
    begin
       use_wchar:=(a.flag1 and bm_TGtkEntry_use_wchar) shr bp_TGtkEntry_use_wchar;
    end;

procedure set_use_wchar(var a : TGtkEntry; __use_wchar : guint);
    begin
       a.flag1:=a.flag1 or ((__use_wchar shl bp_TGtkEntry_use_wchar) and bm_TGtkEntry_use_wchar);
    end;
{$endif}

function  GTK_ENTRY_TYPE:TGtkType;cdecl;external gtkdll name 'gtk_entry_get_type';
function  GTK_IS_ENTRY(obj:pointer):boolean;
begin
  GTK_IS_ENTRY:=(obj<>nil) and GTK_IS_ENTRY_CLASS(PGtkTypeObject(obj)^.klass);
end;
function  GTK_IS_ENTRY_CLASS(klass:pointer):boolean;
begin
  GTK_IS_ENTRY_CLASS:=(klass<>nil) and (PGtkTypeClass(klass)^.thetype=GTK_ENTRY_TYPE);
end;

function  gtk_entry_get_type:TGtkType;cdecl;external gtkdll name 'gtk_entry_get_type';
procedure gtk_entry_set_text(entry:PGtkEntry; text:Pgchar);cdecl;external gtkdll name 'gtk_entry_set_text';
procedure gtk_entry_append_text(entry:PGtkEntry; text:Pgchar);cdecl;external gtkdll name 'gtk_entry_append_text';
procedure gtk_entry_prepend_text(entry:PGtkEntry; text:Pgchar);cdecl;external gtkdll name 'gtk_entry_prepend_text';
procedure gtk_entry_set_position(entry:PGtkEntry; position:gint);cdecl;external gtkdll name 'gtk_entry_set_position';
procedure gtk_entry_select_region(entry:PGtkEntry; start:gint; theend:gint);cdecl;external gtkdll name 'gtk_entry_select_region';
procedure gtk_entry_set_visibility(entry:PGtkEntry; visible:gboolean);cdecl;external gtkdll name 'gtk_entry_set_visibility';
procedure gtk_entry_set_editable(entry:PGtkEntry; editable:gboolean);cdecl;external gtkdll name 'gtk_entry_set_editable';
procedure gtk_entry_set_max_length(entry:PGtkEntry; max:guint16);cdecl;external gtkdll name 'gtk_entry_set_max_length';
function  gtk_entry_get_text (entry:PGtkEntry):Pgchar;cdecl;external gtkdll name 'gtk_entry_get_text';
function  gtk_entry_new :PGtkWidget;cdecl;external gtkdll name 'gtk_entry_new';
function  gtk_entry_new_with_max_length (max:guint16):PGtkWidget;cdecl;external gtkdll name 'gtk_entry_new_with_max_length';

{$endif read_implementation}


{
  $Log: gtkentry.pp,v $
  Revision 1.7  1999/05/11 00:38:29  peter
    * win32 fixes

  Revision 1.6  1999/05/10 15:19:17  peter
    * cdecl fixes

  Revision 1.5  1999/05/10 09:03:08  peter
    * gtk 1.2 port working

  Revision 1.4  1998/11/09 10:09:49  peter
    + C type casts are now correctly handled

  Revision 1.3  1998/10/21 20:22:25  peter
    * cdecl, packrecord fixes (from the gtk.tar.gz)
    * win32 support
    * gtk.pp,gdk.pp for an all in one unit

}

