{
   $Id: gtkobjects.pp,v 1.13 1999/06/29 23:46:53 peter Exp $
}

{****************************************************************************
                                 Interface
****************************************************************************}

{$ifdef read_interface}

{$ifdef GTK10}

type
{$PACKRECORDS 4}
     TGtkType = guint;
     PGtkType = ^TGtkType;

     TGtkFundamentalType = (GTK_TYPE_INVALID,GTK_TYPE_NONE,GTK_TYPE_CHAR,
       GTK_TYPE_UCHAR,GTK_TYPE_BOOL,GTK_TYPE_INT,
       GTK_TYPE_UINT,GTK_TYPE_LONG,GTK_TYPE_ULONG,
       GTK_TYPE_FLOAT,GTK_TYPE_DOUBLE,GTK_TYPE_STRING,
       GTK_TYPE_ENUM,GTK_TYPE_FLAGS,GTK_TYPE_BOXED,
       GTK_TYPE_POINTER,GTK_TYPE_SIGNAL,GTK_TYPE_ARGS,
       GTK_TYPE_CALLBACK,GTK_TYPE_C_CALLBACK,
       GTK_TYPE_FOREIGN,GTK_TYPE_OBJECT);

       PGtkTypeObject = ^TGtkTypeObject;
       PGtkTypeClass = ^TGtkTypeClass;

       TGtkTypeObject = record
            klass : PGtkTypeClass;
         end;

       TGtkTypeClass = record
            thetype : TGtkType;
         end;

   PGtkObjectClass = ^TGtkObjectClass;
   PGtkObject = ^TGtkObject;
   TGtkObject = record
        klass : PGtkObjectClass;
        flags : guint32;
        ref_count : guint;
        object_data : gpointer;
     end;
{$PACKRECORDS 4}
   TGtkObjectClass = record
        thetype : TGtkType;
        signals : Pguint;
        nsignals : guint;
        n_args : guint;
        shutdown : procedure(theobject:PGtkObject); cdecl;
        destroy : procedure(theobject:PGtkObject); cdecl;
        finalize : procedure(theobject:PGtkObject); cdecl;
     end;

   PGtkCallbackMarshal = ^TGtkCallbackMarshal;
   PGtkArg = ^TGtkArg;
   PGtkDestroyNotify = ^TGtkDestroyNotify;
   PGtkfunction = ^TGtkfunction;
   TGtkCallbackMarshal = procedure(theobject:PGtkObject; data:gpointer; n_args:guint; args:PGtkArg); cdecl;
   TGtkDestroyNotify = procedure(data:gpointer); cdecl;
   TGtkfunction = function(data:gpointer):gint; cdecl;
{$PACKRECORDS 4}
   TCallback_data = record
                    marshal : TGtkCallbackMarshal;
                    data : gpointer;
                    notify : TGtkDestroyNotify;
                 end;
{$PACKRECORDS 4}
   TForeign_data = record
                    data : gpointer;
                    notify : TGtkDestroyNotify;
                 end;
{$PACKRECORDS 4}
   Targs_data = record
                    n_args : gint;
                    args : PGtkArg;
                 end;
{$PACKRECORDS 4}
   Tsignal_data = record
                    f : TGtkfunction ;
                    d : gpointer;
                 end;
{$PACKRECORDS 4}
   Tc_callback_data = record
                    func : TGtkfunction ;
                    func_data : gpointer;
                 end ;

   TGtkArg = record
        thetype : TGtkType;
        name : Pgchar;
        d : record
            case longint of
               0 : ( char_data:gchar );
               1 : ( int_data:gint );
               2 : ( uint_data:guint );
               3 : ( bool_data:gint );
               4 : ( long_data:glong );
               5 : ( ulong_data:gulong );
               6 : ( float_data:gfloat );
               7 : ( double_data:gdouble );
               8 : ( string_data:Pgchar );
               9 : ( pointer_data:gpointer );
               10 : ( object_data:PGtkObject );
               11 : ( callback_data : TCallback_data );
               12 : (foreign_data : TForeign_data);
               13 : (args_data: Targs_data);
               14 : (signal_data : Tsignal_data);
               15 : (c_callback_data: Tc_callback_data);
          end;
     end;

   PGtkClassInitFunc = ^TGtkClassInitFunc;
   TGtkClassInitFunc = procedure(klass:gpointer); cdecl;
   PGtkObjectInitFunc = ^TGtkObjectInitFunc;
   TGtkObjectInitFunc = procedure(theobject:gpointer); cdecl;
   PGtkArgGetFunc = ^TGtkArgGetFunc;
   TGtkArgGetFunc = procedure(theobject:PGtkObject; arg:PGtkArg; arg_id:guint); cdecl;
   PGtkArgSetFunc = ^TGtkArgSetFunc;
   TGtkArgSetFunc = procedure(theobject:PGtkObject; arg:PGtkArg; arg_id:guint); cdecl;

    function GTK_VALUE_CHAR(a : TGtkArg) : gchar;
    function GTK_VALUE_BOOL(a : TGtkArg) : gint;
    function GTK_VALUE_INT(a : TGtkArg) : gint;
    function GTK_VALUE_UINT(a : TGtkArg) : guint;
    function GTK_VALUE_LONG(a : TGtkArg) : glong;
    function GTK_VALUE_ULONG(a : TGtkArg) : gulong;
    function GTK_VALUE_FLOAT(a : TGtkArg) : gfloat;
    function GTK_VALUE_DOUBLE(a : TGtkArg) : gdouble;
    function GTK_VALUE_STRING(a : TGtkArg) : Pgchar;
    function GTK_VALUE_ENUM(a : TGtkArg) : gint;
    function GTK_VALUE_FLAGS(a : TGtkArg) : gint;
    function GTK_VALUE_BOXED(a : TGtkArg) : gpointer;
    function GTK_VALUE_FOREIGN(a : TGtkArg) : Tforeign_data;
    function GTK_VALUE_CALLBACK(a : TGtkArg) : TCallback_data;
    function GTK_VALUE_ARGS(a : TGtkArg) : Targs_data;
    function GTK_VALUE_OBJECT(a : TGtkArg) : PGtkobject;
    function GTK_VALUE_POINTER(a : TGtkArg) : gpointer;
    function GTK_VALUE_SIGNAL(a : TGtkArg) : TSignal_data;
    function GTK_VALUE_C_CALLBACK(a : TGtkArg) : TC_callback_data;

    function GTK_RETLOC_CHAR(a : TGtkArg) : Pgchar;
    function GTK_RETLOC_BOOL(a : TGtkArg) : gint;
    function GTK_RETLOC_INT(a : TGtkArg) : gint;
    function GTK_RETLOC_UINT(a : TGtkArg) : guint;
    function GTK_RETLOC_LONG(a : TGtkArg) : glong;
    function GTK_RETLOC_ULONG(a : TGtkArg) : gulong;
    function GTK_RETLOC_FLOAT(a : TGtkArg) : gfloat;
    function GTK_RETLOC_DOUBLE(a : TGtkArg) : gdouble;
    function GTK_RETLOC_STRING(a : TGtkArg) : Pgchar;
    function GTK_RETLOC_ENUM(a : TGtkArg) : gint;
    function GTK_RETLOC_FLAGS(a : TGtkArg) : gint;
    function GTK_RETLOC_BOXED(a : TGtkArg) : gpointer;
    function GTK_RETLOC_OBJECT(a : TGtkArg) : TGtkObject;
    function GTK_RETLOC_POINTER(a : TGtkArg) : gpointer;

Type
   PGtkTypeInfo = ^TGtkTypeInfo;
{$PACKRECORDS 4}
   TGtkTypeInfo = record
        type_name : Pgchar;
        object_size : guint;
        class_size : guint;
        class_init_func : TGtkClassInitFunc;
        object_init_func : TGtkObjectInitFunc;
        arg_set_func : TGtkArgSetFunc;
        arg_get_func : TGtkArgGetFunc;
     end;

var
  gtk_type_builtins : array[0..121] of TGtkType;external gtkdll name 'gtk_type_builtins';

procedure gtk_type_init;cdecl;
function  gtk_type_unique(parent_type:guint; type_info:PGtkTypeInfo):TGtkType;cdecl;
function  gtk_type_name(thetype:guint):Pgchar;cdecl;
function  gtk_type_from_name(name:Pgchar):TGtkType;cdecl;
function  gtk_type_parent(thetype:TGtkType):TGtkType;cdecl;
function  gtk_type_class(thetype:TGtkType):gpointer;cdecl;
function  gtk_type_new(thetype:TGtkType):gpointer;cdecl;
procedure gtk_type_describe_heritage(thetype:TGtkType);cdecl;
procedure gtk_type_describe_tree(thetype:TGtkType; show_size:gint);cdecl;
function  gtk_type_is_a(thetype:TGtkType; is_a_thetype:TGtkType):gint;cdecl;
{$ifndef gtkwin}
procedure gtk_type_get_arg(theobject:PGtkObject; thetype:TGtkType; arg:PGtkArg; arg_id:guint);cdecl;
procedure gtk_type_set_arg(theobject:PGtkObject; thetype:TGtkType; arg:PGtkArg; arg_id:guint);cdecl;
function  gtk_arg_copy(src_arg:PGtkArg; dest_arg:PGtkArg):PGtkArg;cdecl;
{$endif}

Type
  GTK_OBJECT = PGtkObject;
  GTK_OBJECT_CLASS = PGtkObjectClass;

Const
     GTK_DESTROYED = (1) shl (0);
     GTK_FLOATING = (1) shl (1);
     GTK_RESERVED_1 = (1) shl (2);
     GTK_RESERVED_2 = (1) shl (3);
     GTK_OBJECT_FLAG_LAST = GTK_RESERVED_2;

     GTK_ARG_READABLE = (1) shl (0);
     GTK_ARG_WRITABLE = (1) shl (1);
     GTK_ARG_CONSTRUCT = (1) shl (2);
     GTK_ARG_READWRITE = (GTK_ARG_READABLE) or (GTK_ARG_WRITABLE);

Type
   PGtkSignalFunc = ^TGtkSignalFunc;
   TGtkSignalFunc = procedure; cdecl;
   PGtkSignalMarshaller = ^TGtkSignalMarshaller;
   TGtkSignalMarshaller = procedure(theobject:PGtkObject; func:TGtkSignalFunc; func_data:gpointer; args:PGtkArg); cdecl;

   GTK_SIGNAL_FUNC = TGtkSignalFunc;

    function GTK_OBJECT_FLAGS(obj : PGtkobject) : longint;
    function GTK_OBJECT_DESTROYED(obj : PGtkobject) : boolean;
    function GTK_OBJECT_FLOATING(obj : PGtkobject) : boolean;

function  GTK_OBJECT_TYPE(obj : PGtkobject) : TGtkType;cdecl;
function  GTK_IS_OBJECT(obj:pointer):boolean;
function  GTK_IS_OBJECT_CLASS(klass:pointer):boolean;

function  gtk_object_get_type:TGtkType;cdecl;
function  gtk_object_class_add_user_signal(klass:PGtkObjectClass; name:Pgchar; marshaller:TGtkSignalMarshaller; return_val:TGtkType; nparams:guint; args:array of const):guint;cdecl;
procedure gtk_object_class_add_signals(klass:PGtkObjectClass; signals:Pguint; nsignals:guint); cdecl;
function  gtk_object_new(thetype:TGtkType; args:array of const):PGtkObject;cdecl;
function  gtk_object_newv(thetype:TGtkType; nargs:guint; args:PGtkArg):PGtkObject; cdecl;
procedure gtk_object_sink(theobject:PGtkObject); cdecl;
procedure gtk_object_ref(theobject:PGtkObject); cdecl;
procedure gtk_object_unref(theobject:PGtkObject); cdecl;
procedure gtk_object_weakref(theobject:PGtkObject; notify:TGtkDestroyNotify; data:gpointer); cdecl;
procedure gtk_object_weakunref(theobject:PGtkObject; notify:TGtkDestroyNotify; data:gpointer); cdecl;
procedure gtk_object_destroy(theobject:PGtkObject); cdecl;
procedure gtk_object_getv(theobject:PGtkObject; nargs:guint; args:PGtkArg); cdecl;
procedure gtk_object_set(theobject:PGtkObject; args:array of const);cdecl;
procedure gtk_object_setv(theobject:PGtkObject; nargs:guint; args:PGtkArg); cdecl;
function  gtk_object_query_args(class_thetype:TGtkType; arg_flags:PPguint32; nargs:Pguint):PGtkArg; cdecl;
{$ifndef gtkwin}
procedure gtk_object_add_arg_type(arg_name:Pgchar; arg_thetype:TGtkType; arg_flags:guint; arg_id:guint); cdecl;
function  gtk_object_get_arg_type(arg_name:Pgchar):TGtkType; cdecl;
{$endif}
procedure gtk_object_set_data(theobject:PGtkObject; key:Pgchar; data:gpointer); cdecl;
procedure gtk_object_set_data_full(theobject:PGtkObject; key:Pgchar; data:gpointer; destroy:TGtkDestroyNotify); cdecl;
function  gtk_object_get_data(theobject:PGtkObject; key:Pgchar):gpointer; cdecl;
procedure gtk_object_remove_data(theobject:PGtkObject; key:Pgchar); cdecl;
procedure gtk_object_set_data_by_id(theobject:PGtkObject; data_id:guint; data:gpointer); cdecl;
procedure gtk_object_set_data_by_id_full(theobject:PGtkObject; data_id:guint; data:gpointer; destroy:TGtkDestroyNotify); cdecl;
function  gtk_object_get_data_by_id(theobject:PGtkObject; data_id:guint):gpointer; cdecl;
procedure gtk_object_remove_data_by_id(theobject:PGtkObject; data_id:guint); cdecl;
{$ifndef gtkwin}
function  gtk_object_data_try_key(key:Pgchar):guint; cdecl;
function  gtk_object_data_force_id(key:Pgchar):guint; cdecl;
{$endif}
procedure gtk_object_set_user_data(theobject:PGtkObject; data:gpointer); cdecl;
function  gtk_object_get_user_data(theobject:PGtkObject):gpointer; cdecl;
{$ifndef gtkwin}
function  gtk_object_check_cast(obj:PGtkObject; cast_thetype:TGtkType):PGtkObject; cdecl;
function  gtk_object_check_class_cast(klass:PGtkObjectClass; cast_thetype:TGtkType):PGtkObjectClass; cdecl;
procedure gtk_trace_referencing(theobject:Pgpointer; func:Pgchar;local_frame:guint; line:guint; do_ref:gboolean); cdecl;
{$endif}


{$else GTK10}

{*****************************************************************************}
{                                    GTK 1.2                                  }
{*****************************************************************************}

   type
{$PACKRECORDS 4}

       TGtkType = guint;
       PGtkType = ^TGtkType;

       PGtkArg = ^TGtkArg;
       PGtkTypeClass = ^TGtkTypeClass;
       PGtkObject = ^TGtkObject;
       PGtkObjectClass = ^TGtkObjectClass;

{***************************************
     Inserted from gtktypeutils
***************************************}

       TGtkClassInitFunc = procedure (klass:gpointer);cdecl;

       TGtkObjectInitFunc = procedure (theobject:gpointer; klass:gpointer);cdecl;

       TGtkSignalFunc = procedure ;cdecl;

       TGtkfunction = function (data:gpointer):gint;cdecl;

       TGtkDestroyNotify = procedure (data:gpointer);cdecl;

       TGtkCallbackMarshal = procedure (theobject:PGtkObject; data:gpointer; n_args:guint; args:PGtkArg);cdecl;

       TGtkSignalMarshaller = procedure (theobject:PGtkObject; func:TGtkSignalFunc; func_data:gpointer; args:PGtkArg);cdecl;

       TGtkArgGetFunc = procedure (_para1:PGtkObject; _para2:PGtkArg; _para3:guint);cdecl;

       TGtkArgSetFunc = procedure (_para1:PGtkObject; _para2:PGtkArg; _para3:guint);cdecl;

       GTK_SIGNAL_FUNC = TGtkSignalFunc;

       PGtkTypeObject = ^TGtkTypeObject;
       TGtkTypeObject = record
            klass : PGtkTypeClass;
         end;

       TGtkTypeClass = record
            thetype : TGtkType;
         end;

       TGtkArg = record
            thetype : TGtkType;
            name : Pgchar;
            d : record
                case longint of
                   0 : ( char_data : gchar );
                   1 : ( uchar_data : guchar );
                   2 : ( bool_data : gboolean );
                   3 : ( int_data : gint );
                   4 : ( uint_data : guint );
                   5 : ( long_data : glong );
                   6 : ( ulong_data : gulong );
                   7 : ( float_data : gfloat );
                   8 : ( double_data : gdouble );
                   9 : ( string_data : Pgchar );
                   10 : ( pointer_data : gpointer );
                   11 : ( object_data : PGtkObject );
                   12 : ( signal_data : record
                        f : TGtkSignalFunc;
                        d : gpointer;
                     end );
                   13 : ( args_data : record
                        n_args : gint;
                        args : PGtkArg;
                     end );
                   14 : ( callback_data : record
                        marshal : TGtkCallbackMarshal;
                        data : gpointer;
                        notify : TGtkDestroyNotify;
                     end );
                   15 : ( c_callback_data : record
                        func : TGtkfunction;
                        func_data : gpointer;
                     end );
                   16 : ( foreign_data : record
                        data : gpointer;
                        notify : TGtkDestroyNotify;
                     end );
                end;
         end;

{***************************************
         Inserted from gtkarg
***************************************}

     PGtkArgInfo = ^TGtkArgInfo;
     PPGtkArgInfo = ^PGtkArgInfo;
     TGtkArgInfo = record
          class_type : TGtkType;
          name : Pgchar;
          _type : TGtkType;
          arg_flags : guint;
          full_name : Pgchar;
          arg_id : guint;
          seq_id : guint;
       end;

{***************************************
          End of insertions
***************************************}

       TGtkObject = record
            klass : PGtkObjectClass;
            flags : guint32;
            ref_count : guint;
            object_data : PGData;
         end;

       TGtkObjectClass = record
            thetype : TGtkType;
            signals : Pguint;
            nsignals : guint;
            n_args : guint;
            construct_args : PGSList;
            set_arg : procedure (theobject:PGtkObject; arg:PGtkArg; arg_id:guint);cdecl;
            get_arg : procedure (theobject:PGtkObject; arg:PGtkArg; arg_id:guint);cdecl;
            shutdown : procedure (theobject:PGtkObject);cdecl;
            destroy : procedure (theobject:PGtkObject);cdecl;
            finalize : procedure (theobject:PGtkObject);cdecl;
         end;

     TGtkObjectFlags = longint;
const
     GTK_DESTROYED = 1 shl 0;
     GTK_FLOATING = 1 shl 1;
     GTK_CONNECTED = 1 shl 2;
     GTK_CONSTRUCTED = 1 shl 3;

Type
  GTK_OBJECT = PGtkObject;
  GTK_OBJECT_CLASS = PGtkObjectClass;

function  GTK_OBJECT_TYPE(obj : PGtkobject) : TGtkType;cdecl;
function  GTK_OBJECT_SIGNALS(obj : PGtkobject) : Pguint;
function  GTK_OBJECT_NSIGNALS(obj : PGtkobject) : guint;
function  GTK_OBJECT_FLAGS(obj : PGtkobject) : longint;
function  GTK_OBJECT_DESTROYED(obj : PGtkobject) : boolean;
function  GTK_OBJECT_FLOATING(obj : PGtkobject) : boolean;
function  GTK_OBJECT_CONNECTED(obj : PGtkobject) : boolean;
function  GTK_OBJECT_IS_CONSTRUCTED(obj : PGtkobject) : boolean;

function  GTK_IS_OBJECT(obj:pointer):boolean;
function  GTK_IS_OBJECT_CLASS(klass:pointer):boolean;

function  gtk_object_get_type:TGtkType;cdecl;
function  gtk_object_class_user_signal_new(klass:PGtkObjectClass; name:Pgchar; signal_flags:TGtkSignalRunType; marshaller:TGtkSignalMarshaller; return_val:TGtkType; nparams:guint; args:array of const):guint;cdecl;
function  gtk_object_class_user_signal_newv(klass:PGtkObjectClass; name:Pgchar; signal_flags:TGtkSignalRunType; marshaller:TGtkSignalMarshaller; return_val:TGtkType; nparams:guint; params:PGtkType):guint;cdecl;
function  gtk_object_new(thetype:TGtkType; first_arg_name:Pgchar; args:array of const):PGtkObject;cdecl;
function  gtk_object_newv(theobject_type:TGtkType; n_args:guint; args:PGtkArg):PGtkObject;cdecl;
procedure gtk_object_default_construct(theobject:PGtkObject);cdecl;
procedure gtk_object_constructed(theobject:PGtkObject);cdecl;
procedure gtk_object_sink(theobject:PGtkObject);cdecl;
procedure gtk_object_ref(theobject:PGtkObject);cdecl;
procedure gtk_object_unref(theobject:PGtkObject);cdecl;
procedure gtk_object_weakref(theobject:PGtkObject; notify:TGtkDestroyNotify; data:gpointer);cdecl;
procedure gtk_object_weakunref(theobject:PGtkObject; notify:TGtkDestroyNotify; data:gpointer);cdecl;
procedure gtk_object_destroy(theobject:PGtkObject);cdecl;
procedure gtk_object_getv(theobject:PGtkObject; n_args:guint; args:PGtkArg);cdecl;
{$ifndef gtkwin}
procedure gtk_object_get(theobject:PGtkObject; first_arg_name:Pgchar; args:array of const);cdecl;
procedure gtk_object_set(theobject:PGtkObject; first_arg_name:Pgchar; args:array of const);cdecl;
{$endif}
procedure gtk_object_setv(theobject:PGtkObject; n_args:guint; args:PGtkArg);cdecl;
function  gtk_object_query_args(class_type:TGtkType; arg_flags:PPguint32; n_args:Pguint):PGtkArg;cdecl;
procedure gtk_object_set_data(theobject:PGtkObject; key:Pgchar; data:gpointer);cdecl;
procedure gtk_object_set_data_full(theobject:PGtkObject; key:Pgchar; data:gpointer; destroy:TGtkDestroyNotify);cdecl;
procedure gtk_object_remove_data(theobject:PGtkObject; key:Pgchar);cdecl;
function  gtk_object_get_data(theobject:PGtkObject; key:Pgchar):gpointer;cdecl;
{$ifndef gtkwin}
procedure gtk_object_remove_no_notify(theobject:PGtkObject; key:Pgchar);cdecl;
{$endif}
procedure gtk_object_set_user_data(theobject:PGtkObject; data:gpointer);cdecl;
function  gtk_object_get_user_data(theobject:PGtkObject):gpointer;cdecl;
procedure gtk_object_class_add_signals(klass:PGtkObjectClass; signals:Pguint; nsignals:guint);cdecl;
procedure gtk_object_add_arg_type(arg_name:Pgchar; arg_type:TGtkType; arg_flags:guint; arg_id:guint);cdecl;
procedure gtk_object_set_data_by_id(theobject:PGtkObject; data_id:TGQuark; data:gpointer);cdecl;
procedure gtk_object_set_data_by_id_full(theobject:PGtkObject; data_id:TGQuark; data:gpointer; destroy:TGtkDestroyNotify);cdecl;
function  gtk_object_get_data_by_id(theobject:PGtkObject; data_id:TGQuark):gpointer;cdecl;
procedure gtk_object_remove_data_by_id(theobject:PGtkObject; data_id:TGQuark);cdecl;
{$ifndef gtkwin}
procedure gtk_object_remove_no_notify_by_id(theobject:PGtkObject; key_id:TGQuark);cdecl;
{$endif}
procedure gtk_object_arg_set(theobject:PGtkObject; arg:PGtkArg; info:PGtkArgInfo);cdecl;
procedure gtk_object_arg_get(theobject:PGtkObject; arg:PGtkArg; info:PGtkArgInfo);cdecl;
function  gtk_object_args_collect(theobject_type:TGtkType; arg_list_p:PPGSList; info_list_p:PPGSList; first_arg_name:Pgchar; var_args:array of const):Pgchar;cdecl;
function  gtk_object_arg_get_info(theobject_type:TGtkType; arg_name:Pgchar; info_p:PPGtkArgInfo):Pgchar;cdecl;
procedure gtk_trace_referencing(theobject:PGtkObject; func:Pgchar; dummy:guint; line:guint; do_ref:gboolean);cdecl;

{    const
       gtk_object_data_try_key = g_quark_try_string;
       gtk_object_data_force_id = g_quark_from_string; }

{$endif GTK10}


{$endif read_interface}


{****************************************************************************
                              Implementation
****************************************************************************}

{$ifdef read_implementation}


{$ifdef GTK10}

procedure gtk_type_init;cdecl;external gtkdll name 'gtk_type_init';
function  gtk_type_unique(parent_type:guint; type_info:PGtkTypeInfo):TGtkType;cdecl;external gtkdll name 'gtk_type_unique';
function  gtk_type_name(thetype:guint):Pgchar;cdecl;external gtkdll name 'gtk_type_name';
function  gtk_type_from_name(name:Pgchar):TGtkType;cdecl;external gtkdll name 'gtk_type_from_name';
function  gtk_type_parent(thetype:TGtkType):TGtkType;cdecl;external gtkdll name 'gtk_type_parent';
function  gtk_type_class(thetype:TGtkType):gpointer;cdecl;external gtkdll name 'gtk_type_class';
function  gtk_type_new(thetype:TGtkType):gpointer;cdecl;external gtkdll name 'gtk_type_new';
procedure gtk_type_describe_heritage(thetype:TGtkType);cdecl;external gtkdll name 'gtk_type_describe_heritage';
procedure gtk_type_describe_tree(thetype:TGtkType; show_size:gint);cdecl;external gtkdll name 'gtk_type_describe_tree';
function  gtk_type_is_a(thetype:TGtkType; is_a_thetype:TGtkType):gint;cdecl;external gtkdll name 'gtk_type_is_a';
{$ifndef gtkwin}
procedure gtk_type_get_arg(theobject:PGtkObject; thetype:TGtkType; arg:PGtkArg; arg_id:guint);cdecl;external gtkdll name 'gtk_type_get_arg';
procedure gtk_type_set_arg(theobject:PGtkObject; thetype:TGtkType; arg:PGtkArg; arg_id:guint);cdecl;external gtkdll name 'gtk_type_set_arg';
function  gtk_arg_copy(src_arg:PGtkArg; dest_arg:PGtkArg):PGtkArg;cdecl;external gtkdll name 'gtk_arg_copy';
function  GTK_OBJECT_TYPE(obj : PGtkobject) : TGtkType;cdecl;
begin
  GTK_OBJECT_TYPE:=obj^.klass^.thetype;
end;
function  GTK_IS_OBJECT(obj:pointer):boolean;
begin
  GTK_IS_OBJECT:=true;
end;
function  GTK_IS_OBJECT_CLASS(klass:pointer):boolean;
begin
  GTK_IS_OBJECT_CLASS:=true;
end;

function  gtk_object_get_type:TGtkType;cdecl;external gtkdll name 'gtk_object_get_thetype';
{$endif}
function  gtk_object_class_add_user_signal(klass:PGtkObjectClass; name:Pgchar; marshaller:TGtkSignalMarshaller; return_val:TGtkType; nparams:guint; args:array of const):guint;cdecl;external gtkdll name 'gtk_object_class_add_user_signal';
procedure gtk_object_class_add_signals(klass:PGtkObjectClass; signals:Pguint; nsignals:guint);cdecl;external gtkdll name 'gtk_object_class_add_signals';
function  gtk_object_new(thetype:TGtkType; args:array of const):PGtkObject;cdecl;external gtkdll name 'gtk_object_new';
function  gtk_object_newv(thetype:TGtkType; nargs:guint; args:PGtkArg):PGtkObject;cdecl;external gtkdll name 'gtk_object_newv';
procedure gtk_object_sink(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_sink';
procedure gtk_object_ref(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_ref';
procedure gtk_object_unref(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_unref';
procedure gtk_object_weakref(theobject:PGtkObject; notify:TGtkDestroyNotify; data:gpointer);cdecl;external gtkdll name 'gtk_object_weakref';
procedure gtk_object_weakunref(theobject:PGtkObject; notify:TGtkDestroyNotify; data:gpointer);cdecl;external gtkdll name 'gtk_object_weakunref';
procedure gtk_object_destroy(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_destroy';
procedure gtk_object_getv(theobject:PGtkObject; nargs:guint; args:PGtkArg);cdecl;external gtkdll name 'gtk_object_getv';
procedure gtk_object_set(theobject:PGtkObject; args:array of const);cdecl;external gtkdll name 'gtk_object_set';
procedure gtk_object_setv(theobject:PGtkObject; nargs:guint; args:PGtkArg);cdecl;external gtkdll name 'gtk_object_setv';
function  gtk_object_query_args(class_thetype:TGtkType; arg_flags:PPguint32; nargs:Pguint):PGtkArg;cdecl;external gtkdll name 'gtk_object_query_args';
{$ifndef gtkwin}
procedure gtk_object_add_arg_type(arg_name:Pgchar; arg_thetype:TGtkType; arg_flags:guint; arg_id:guint);cdecl;external gtkdll name 'gtk_object_add_arg_type';
function  gtk_object_get_arg_type(arg_name:Pgchar):TGtkType;cdecl;external gtkdll name 'gtk_object_get_arg_type';
{$endif}
procedure gtk_object_set_data(theobject:PGtkObject; key:Pgchar; data:gpointer);cdecl;external gtkdll name 'gtk_object_set_data';
procedure gtk_object_set_data_full(theobject:PGtkObject; key:Pgchar; data:gpointer; destroy:TGtkDestroyNotify);cdecl;external gtkdll name 'gtk_object_set_data_full';
function  gtk_object_get_data(theobject:PGtkObject; key:Pgchar):gpointer;cdecl;external gtkdll name 'gtk_object_get_data';
procedure gtk_object_remove_data(theobject:PGtkObject; key:Pgchar);cdecl;external gtkdll name 'gtk_object_remove_data';
procedure gtk_object_set_data_by_id(theobject:PGtkObject; data_id:guint; data:gpointer);cdecl;external gtkdll name 'gtk_object_set_data_by_id';
procedure gtk_object_set_data_by_id_full(theobject:PGtkObject; data_id:guint; data:gpointer; destroy:TGtkDestroyNotify);cdecl;external gtkdll name 'gtk_object_set_data_by_id_full';
function  gtk_object_get_data_by_id(theobject:PGtkObject; data_id:guint):gpointer;cdecl;external gtkdll name 'gtk_object_get_data_by_id';
procedure gtk_object_remove_data_by_id(theobject:PGtkObject; data_id:guint);cdecl;external gtkdll name 'gtk_object_remove_data_by_id';
{$ifndef gtkwin}
function  gtk_object_data_try_key(key:Pgchar):guint;cdecl;external gtkdll name 'gtk_object_data_try_key';
function  gtk_object_data_force_id(key:Pgchar):guint;cdecl;external gtkdll name 'gtk_object_data_force_id';
{$endif}
procedure gtk_object_set_user_data(theobject:PGtkObject; data:gpointer);cdecl;external gtkdll name 'gtk_object_set_user_data';
function  gtk_object_get_user_data(theobject:PGtkObject):gpointer;cdecl;external gtkdll name 'gtk_object_get_user_data';
{$ifndef gtkwin}
function  gtk_object_check_cast(obj:PGtkObject; cast_thetype:TGtkType):PGtkObject;cdecl;external gtkdll name 'gtk_object_check_cast';
function  gtk_object_check_class_cast(klass:PGtkObjectClass; cast_thetype:TGtkType):PGtkObjectClass;cdecl;external gtkdll name 'gtk_object_check_class_cast';
procedure gtk_trace_referencing(theobject:Pgpointer; func:Pgchar; local_frame:guint; line:guint; do_ref:gboolean);cdecl;external gtkdll name 'gtk_trace_referencing';
{$endif}


{ Manually inserted functions }

    function GTK_VALUE_CHAR(a : TGtkArg) : gchar;

      begin
         GTK_VALUE_CHAR:=a.d.char_data;
      end;
    function GTK_VALUE_BOOL(a : TGtkArg) : gint;

      begin
         GTK_VALUE_BOOL:=a.d.bool_data;
      end;
    function GTK_VALUE_INT(a : TGtkArg) : gint;

      begin
         GTK_VALUE_INT:=a.d.int_data;
      end;
    function GTK_VALUE_UINT(a : TGtkArg) : guint;

      begin
         GTK_VALUE_UINT:=a.d.uint_data;
      end;
    function GTK_VALUE_LONG(a : TGtkArg) : glong;

      begin
         GTK_VALUE_LONG:=a.d.long_data;
      end;
    function GTK_VALUE_ULONG(a : TGtkArg) : gulong;

      begin
         GTK_VALUE_ULONG:=a.d.ulong_data;
      end;
    function GTK_VALUE_FLOAT(a : TGtkArg) : gfloat;

      begin
         GTK_VALUE_FLOAT:=a.d.float_data;
      end;
    function GTK_VALUE_DOUBLE(a : TGtkArg) : gdouble;

      begin
         GTK_VALUE_DOUBLE:=a.d.double_data;
      end;
    function GTK_VALUE_STRING(a : TGtkArg) : Pgchar;

      begin
         GTK_VALUE_STRING:=a.d.string_data;
      end;
    function GTK_VALUE_ENUM(a : TGtkArg) : gint;

      begin
         GTK_VALUE_ENUM:=a.d.int_data;
      end;
    function GTK_VALUE_FLAGS(a : TGtkArg) : gint;

      begin
         GTK_VALUE_FLAGS:=a.d.int_data;
      end;
    function GTK_VALUE_BOXED(a : TGtkArg) : gpointer;

      begin
         GTK_VALUE_BOXED:=a.d.pointer_data;
      end;
    function GTK_VALUE_FOREIGN(a : TGtkArg) : TForeign_data;

      begin
         GTK_VALUE_FOREIGN:=a.d.foreign_data;
      end;
    function GTK_VALUE_CALLBACK(a : TGtkArg) : TCallback_data;

      begin
         GTK_VALUE_CALLBACK:=a.d.callback_data;
      end;
    function GTK_VALUE_ARGS(a : TGtkArg) : Targs_data;

      begin
         GTK_VALUE_ARGS:=a.d.args_data;
      end;
    function GTK_VALUE_OBJECT(a : TGtkArg) : PGtkobject;

      begin
         GTK_VALUE_OBJECT:=a.d.object_data;
      end;
    function GTK_VALUE_POINTER(a : TGtkArg) : gpointer;

      begin
         GTK_VALUE_POINTER:=a.d.pointer_data;
      end;
    function GTK_VALUE_SIGNAL(a : TGtkArg) : TSignal_Data;

      begin
         GTK_VALUE_SIGNAL:=a.d.signal_data;
      end;
    function GTK_VALUE_C_CALLBACK(a : TGtkArg) : Tc_callback_data;

      begin
         GTK_VALUE_C_CALLBACK:=a.d.c_callback_data;
      end;

    function GTK_RETLOC_CHAR(a : TGtkArg) : Pgchar;
      begin
         GTK_RETLOC_CHAR:=Pgchar(a.d.pointer_data);
      end;
    function GTK_RETLOC_BOOL(a : TGtkArg) : gint;
      begin
         GTK_RETLOC_BOOL:=gint(a.d.pointer_data);
      end;
    function GTK_RETLOC_INT(a : TGtkArg) : gint;
      begin
         GTK_RETLOC_INT:=gint(a.d.pointer_data);
      end;
    function GTK_RETLOC_UINT(a : TGtkArg) : guint;
      begin
         GTK_RETLOC_UINT:=guint(a.d.pointer_data);
      end;
    function GTK_RETLOC_LONG(a : TGtkArg) : glong;
      begin
         GTK_RETLOC_LONG:=glong(a.d.pointer_data);
      end;
    function GTK_RETLOC_ULONG(a : TGtkArg) : gulong;
      begin
         GTK_RETLOC_ULONG:=gulong(a.d.pointer_data);
      end;
    function GTK_RETLOC_FLOAT(a : TGtkArg) : gfloat;
      begin
//         GTK_RETLOC_FLOAT:=gfloat(a.d.pointer_data);
      end;
    function GTK_RETLOC_DOUBLE(a : TGtkArg) : gdouble;
      begin
//         GTK_RETLOC_DOUBLE:=gdouble(a.d.pointer_data);
      end;
    function GTK_RETLOC_STRING(a : TGtkArg) : Pgchar;
      begin
//         GTK_RETLOC_STRING:=Pgchar(a.d.pointer_data);
      end;
    function GTK_RETLOC_ENUM(a : TGtkArg) : gint;
      begin
//         GTK_RETLOC_ENUM:=gint(a.d.pointer_data);
      end;
    function GTK_RETLOC_FLAGS(a : TGtkArg) : gint;
      begin
//         GTK_RETLOC_FLAGS:=gint(a.d.pointer_data);
      end;
    function GTK_RETLOC_BOXED(a : TGtkArg) : gpointer;
      begin
         GTK_RETLOC_BOXED:=gpointer(a.d.pointer_data);
      end;
    function GTK_RETLOC_OBJECT(a : TGtkArg) : TGtkObject;
      begin
//         GTK_RETLOC_OBJECT:=GtkObject(a.d.pointer_data);
      end;
    function GTK_RETLOC_POINTER(a : TGtkArg) : gpointer;
      begin
//       GTK_RETLOC_POINTER:=gpointer(a.d.pointer_data);
      end;

{$ifndef gtkwin}

function  GTK_TYPE_WINDOW_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_WINDOW_TYPE:=gtk_type_builtins[0];
end;

function  GTK_TYPE_STATE_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_STATE_TYPE:=gtk_type_builtins[1];
end;

function  GTK_TYPE_DIRECTION_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_DIRECTION_TYPE:=gtk_type_builtins[2];
end;

function  GTK_TYPE_SHADOW_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_SHADOW_TYPE:=gtk_type_builtins[3];
end;

function  GTK_TYPE_ARROW_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_ARROW_TYPE:=gtk_type_builtins[4];
end;

function  GTK_TYPE_PACK_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_PACK_TYPE:=gtk_type_builtins[5];
end;

function  GTK_TYPE_POLICY_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_POLICY_TYPE:=gtk_type_builtins[6];
end;

function  GTK_TYPE_UPDATE_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_UPDATE_TYPE:=gtk_type_builtins[7];
end;

function  GTK_TYPE_ATTACH_OPTIONS : TGtkType;cdecl;
begin
GTK_TYPE_ATTACH_OPTIONS:=gtk_type_builtins[8];
end;

function  GTK_TYPE_SIGNAL_RUN_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_SIGNAL_RUN_TYPE:=gtk_type_builtins[9];
end;

function  GTK_TYPE_WINDOW_POSITION : TGtkType;cdecl;
begin
GTK_TYPE_WINDOW_POSITION:=gtk_type_builtins[10];
end;

function  GTK_TYPE_SUBMENU_DIRECTION : TGtkType;cdecl;
begin
GTK_TYPE_SUBMENU_DIRECTION:=gtk_type_builtins[11];
end;

function  GTK_TYPE_SUBMENU_PLACEMENT : TGtkType;cdecl;
begin
GTK_TYPE_SUBMENU_PLACEMENT:=gtk_type_builtins[12];
end;

function  GTK_TYPE_MENU_FACTORY_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_MENU_FACTORY_TYPE:=gtk_type_builtins[13];
end;

function  GTK_TYPE_METRIC_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_METRIC_TYPE:=gtk_type_builtins[14];
end;

function  GTK_TYPE_SCROLL_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_SCROLL_TYPE:=gtk_type_builtins[15];
end;

function  GTK_TYPE_TROUGH_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_TROUGH_TYPE:=gtk_type_builtins[16];
end;

function  GTK_TYPE_POSITION_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_POSITION_TYPE:=gtk_type_builtins[17];
end;

function  GTK_TYPE_PREVIEW_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_PREVIEW_TYPE:=gtk_type_builtins[18];
end;

function  GTK_TYPE_WIDGET_FLAGS : TGtkType;cdecl;
begin
GTK_TYPE_WIDGET_FLAGS:=gtk_type_builtins[19];
end;

function  GTK_TYPE_SELECTION_MODE : TGtkType;cdecl;
begin
GTK_TYPE_SELECTION_MODE:=gtk_type_builtins[20];
end;

function  GTK_TYPE_CURVE_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_CURVE_TYPE:=gtk_type_builtins[21];
end;

function  GTK_TYPE_FUNDAMENTAL_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_FUNDAMENTAL_TYPE:=gtk_type_builtins[22];
end;

function  GTK_TYPE_JUSTIFICATION : TGtkType;cdecl;
begin
GTK_TYPE_JUSTIFICATION:=gtk_type_builtins[23];
end;

function  GTK_TYPE_GDK_WINDOW_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_WINDOW_TYPE:=gtk_type_builtins[24];
end;

function  GTK_TYPE_GDK_WINDOW_CLASS : TGtkType;cdecl;
begin
GTK_TYPE_GDK_WINDOW_CLASS:=gtk_type_builtins[25];
end;

function  GTK_TYPE_GDK_IMAGE_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_IMAGE_TYPE:=gtk_type_builtins[26];
end;

function  GTK_TYPE_GDK_VISUAL_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_VISUAL_TYPE:=gtk_type_builtins[27];
end;

function  GTK_TYPE_GDK_WINDOW_ATTRIBUTES_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_WINDOW_ATTRIBUTES_TYPE:=gtk_type_builtins[28];
end;

function  GTK_TYPE_GDK_WINDOW_HINTS : TGtkType;cdecl;
begin
GTK_TYPE_GDK_WINDOW_HINTS:=gtk_type_builtins[29];
end;

function  GTK_TYPE_GDK_function : TGtkType;
begin
GTK_TYPE_GDK_function:=gtk_type_builtins[30];
end;

function  GTK_TYPE_GDK_FILL : TGtkType;cdecl;
begin
GTK_TYPE_GDK_FILL:=gtk_type_builtins[31];
end;

function  GTK_TYPE_GDK_LINE_STYLE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_LINE_STYLE:=gtk_type_builtins[32];
end;

function  GTK_TYPE_GDK_CAP_STYLE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_CAP_STYLE:=gtk_type_builtins[33];
end;

function  GTK_TYPE_GDK_JOIN_STYLE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_JOIN_STYLE:=gtk_type_builtins[34];
end;

function  GTK_TYPE_GDK_CURSOR_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_CURSOR_TYPE:=gtk_type_builtins[35];
end;

function  GTK_TYPE_GDK_EVENT_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_EVENT_TYPE:=gtk_type_builtins[36];
end;

function  GTK_TYPE_GDK_EVENT_MASK : TGtkType;cdecl;
begin
GTK_TYPE_GDK_EVENT_MASK:=gtk_type_builtins[37];
end;

function  GTK_TYPE_GDK_NOTIFY_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_NOTIFY_TYPE:=gtk_type_builtins[38];
end;

function  GTK_TYPE_GDK_MODIFIER_TYPE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_MODIFIER_TYPE:=gtk_type_builtins[39];
end;

function  GTK_TYPE_GDK_SUBWINDOW_MODE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_SUBWINDOW_MODE:=gtk_type_builtins[40];
end;

function  GTK_TYPE_GDK_INPUT_CONDITION : TGtkType;cdecl;
begin
GTK_TYPE_GDK_INPUT_CONDITION:=gtk_type_builtins[41];
end;

function  GTK_TYPE_GDK_STATUS : TGtkType;cdecl;
begin
GTK_TYPE_GDK_STATUS:=gtk_type_builtins[42];
end;

function  GTK_TYPE_GDK_BYTE_ORDER : TGtkType;cdecl;
begin
GTK_TYPE_GDK_BYTE_ORDER:=gtk_type_builtins[43];
end;

function  GTK_TYPE_GDK_GCVALUES_MASK : TGtkType;cdecl;
begin
GTK_TYPE_GDK_GCVALUES_MASK:=gtk_type_builtins[44];
end;

function  GTK_TYPE_GDK_SELECTION : TGtkType;cdecl;
begin
GTK_TYPE_GDK_SELECTION:=gtk_type_builtins[45];
end;

function  GTK_TYPE_GDK_PROPERTY_STATE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_PROPERTY_STATE:=gtk_type_builtins[46];
end;

function  GTK_TYPE_GDK_PROP_MODE : TGtkType;cdecl;
begin
GTK_TYPE_GDK_PROP_MODE:=gtk_type_builtins[47];
end;

function  GTK_TYPE_ACCELERATOR_TABLE : TGtkType;cdecl;
begin
GTK_TYPE_ACCELERATOR_TABLE:=gtk_type_builtins[48];
end;

function  GTK_TYPE_STYLE : TGtkType;cdecl;
begin
GTK_TYPE_STYLE:=gtk_type_builtins[49];
end;

function  GTK_TYPE_GDK_COLORMAP : TGtkType;cdecl;
begin
GTK_TYPE_GDK_COLORMAP:=gtk_type_builtins[50];
end;

function  GTK_TYPE_GDK_VISUAL : TGtkType;cdecl;
begin
GTK_TYPE_GDK_VISUAL:=gtk_type_builtins[51];
end;

function  GTK_TYPE_GDK_FONT : TGtkType;cdecl;
begin
GTK_TYPE_GDK_FONT:=gtk_type_builtins[52];
end;

function  GTK_TYPE_GDK_WINDOW : TGtkType;cdecl;
begin
GTK_TYPE_GDK_WINDOW:=gtk_type_builtins[53];
end;

function  GTK_TYPE_GDK_EVENT : TGtkType;cdecl;
begin
GTK_TYPE_GDK_EVENT:=gtk_type_builtins[54];
end;

function  GTK_TYPE_GDK_COLOR : TGtkType;cdecl;
begin
GTK_TYPE_GDK_COLOR:=gtk_type_builtins[55];
end;

function  GTK_TYPE_NUM_BUILTINS : longint;
begin
GTK_TYPE_NUM_BUILTINS:=56;
end;

    function GTK_OBJECT_FLAGS(obj : PGtkobject) : longint;
      begin
         GTK_OBJECT_FLAGS:=obj^.flags;
      end;

    function GTK_OBJECT_DESTROYED(obj : PGtkobject) : boolean;
      begin
         GTK_OBJECT_DESTROYED:=(GTK_OBJECT_FLAGS(obj)) and longint(GTK_DESTROYED)<>0;
      end;

    function GTK_OBJECT_FLOATING(obj : PGtkobject) : boolean;
      begin
         GTK_OBJECT_FLOATING:=(GTK_OBJECT_FLAGS(obj)) and longint(GTK_FLOATING)<>0;
      end;

{$endif not win32}

{$else GTK10}

{****************************************************************************}
{                                   GTK 1.2                                  }
{****************************************************************************}

    function GTK_OBJECT_TYPE(obj : PGtkobject) : TGtkType;cdecl;
      begin
        GTK_OBJECT_TYPE:=obj^.klass^.thetype;
      end;

    function GTK_OBJECT_SIGNALS(obj : PGtkobject) : Pguint;
      begin
         GTK_OBJECT_SIGNALS:=obj^.klass^.signals;
      end;

    function GTK_OBJECT_NSIGNALS(obj : PGtkobject) : guint;
      begin
         GTK_OBJECT_NSIGNALS:=obj^.klass^.nsignals;
      end;

    function GTK_OBJECT_FLAGS(obj : PGtkobject) : longint;
      begin
         GTK_OBJECT_FLAGS:=obj^.flags;
      end;

    function GTK_OBJECT_DESTROYED(obj : PGtkobject) : boolean;
      begin
         GTK_OBJECT_DESTROYED:=(GTK_OBJECT_FLAGS(obj)) and longint(GTK_DESTROYED)<>0;
      end;

    function GTK_OBJECT_FLOATING(obj : PGtkobject) : boolean;
      begin
         GTK_OBJECT_FLOATING:=(GTK_OBJECT_FLAGS(obj)) and longint(GTK_FLOATING)<>0;
      end;

    function GTK_OBJECT_CONNECTED(obj : PGtkobject) : boolean;
      begin
         GTK_OBJECT_CONNECTED:=((GTK_OBJECT_FLAGS(obj)) and longint(GTK_CONNECTED)) <> 0;
      end;

    function GTK_OBJECT_IS_CONSTRUCTED(obj : PGtkobject) : boolean;
      begin
         GTK_OBJECT_IS_CONSTRUCTED:=((GTK_OBJECT_FLAGS(obj)) and longint(GTK_CONSTRUCTED)) <> 0;
       end;

function  GTK_IS_OBJECT(obj:pointer):boolean;
begin
  GTK_IS_OBJECT:=(obj<>nil) and GTK_IS_OBJECT_CLASS(PGtkTypeObject(obj)^.klass);
end;
function  GTK_IS_OBJECT_CLASS(klass:pointer):boolean;
begin
  GTK_IS_OBJECT_CLASS:=(klass<>nil) and (PGtkTypeClass(klass)^.thetype=longint(GTK_TYPE_OBJECT));
end;

function  gtk_object_get_type:TGtkType;cdecl;external gtkdll name 'gtk_object_get_type';
function  gtk_object_class_user_signal_new(klass:PGtkObjectClass; name:Pgchar; signal_flags:TGtkSignalRunType; marshaller:TGtkSignalMarshaller; return_val:TGtkType; nparams:guint; args:array of const):guint;cdecl;external gtkdll name 'gtk_object_class_user_signal_new';
function  gtk_object_class_user_signal_newv(klass:PGtkObjectClass; name:Pgchar; signal_flags:TGtkSignalRunType; marshaller:TGtkSignalMarshaller; return_val:TGtkType; nparams:guint; params:PGtkType):guint;cdecl;external gtkdll name 'gtk_object_class_user_signal_newv';
function  gtk_object_new(thetype:TGtkType; first_arg_name:Pgchar; args:array of const):PGtkObject;cdecl;external gtkdll name 'gtk_object_new';
function  gtk_object_newv(theobject_type:TGtkType; n_args:guint; args:PGtkArg):PGtkObject;cdecl;external gtkdll name 'gtk_object_newv';
procedure gtk_object_default_construct(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_default_construct';
procedure gtk_object_constructed(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_constructed';
procedure gtk_object_sink(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_sink';
procedure gtk_object_ref(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_ref';
procedure gtk_object_unref(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_unref';
procedure gtk_object_weakref(theobject:PGtkObject; notify:TGtkDestroyNotify; data:gpointer);cdecl;external gtkdll name 'gtk_object_weakref';
procedure gtk_object_weakunref(theobject:PGtkObject; notify:TGtkDestroyNotify; data:gpointer);cdecl;external gtkdll name 'gtk_object_weakunref';
procedure gtk_object_destroy(theobject:PGtkObject);cdecl;external gtkdll name 'gtk_object_destroy';
procedure gtk_object_getv(theobject:PGtkObject; n_args:guint; args:PGtkArg);cdecl;external gtkdll name 'gtk_object_getv';
{$ifndef gtkwin}
procedure gtk_object_get(theobject:PGtkObject; first_arg_name:Pgchar; args:array of const);cdecl;external gtkdll name 'gtk_object_get';
procedure gtk_object_set(theobject:PGtkObject; first_arg_name:Pgchar; args:array of const);cdecl;external gtkdll name 'gtk_object_set';
{$endif}
procedure gtk_object_setv(theobject:PGtkObject; n_args:guint; args:PGtkArg);cdecl;external gtkdll name 'gtk_object_setv';
function  gtk_object_query_args(class_type:TGtkType; arg_flags:PPguint32; n_args:Pguint):PGtkArg;cdecl;external gtkdll name 'gtk_object_query_args';
procedure gtk_object_set_data(theobject:PGtkObject; key:Pgchar; data:gpointer);cdecl;external gtkdll name 'gtk_object_set_data';
procedure gtk_object_set_data_full(theobject:PGtkObject; key:Pgchar; data:gpointer; destroy:TGtkDestroyNotify);cdecl;external gtkdll name 'gtk_object_set_data_full';
procedure gtk_object_remove_data(theobject:PGtkObject; key:Pgchar);cdecl;external gtkdll name 'gtk_object_remove_data';
function  gtk_object_get_data(theobject:PGtkObject; key:Pgchar):gpointer;cdecl;external gtkdll name 'gtk_object_get_data';
{$ifndef gtkwin}
procedure gtk_object_remove_no_notify(theobject:PGtkObject; key:Pgchar);cdecl;external gtkdll name 'gtk_object_remove_no_notify';
{$endif}
procedure gtk_object_set_user_data(theobject:PGtkObject; data:gpointer);cdecl;external gtkdll name 'gtk_object_set_user_data';
function  gtk_object_get_user_data(theobject:PGtkObject):gpointer;cdecl;external gtkdll name 'gtk_object_get_user_data';
procedure gtk_object_class_add_signals(klass:PGtkObjectClass; signals:Pguint; nsignals:guint);cdecl;external gtkdll name 'gtk_object_class_add_signals';
procedure gtk_object_add_arg_type(arg_name:Pgchar; arg_type:TGtkType; arg_flags:guint; arg_id:guint);cdecl;external gtkdll name 'gtk_object_add_arg_type';
procedure gtk_object_set_data_by_id(theobject:PGtkObject; data_id:TGQuark; data:gpointer);cdecl;external gtkdll name 'gtk_object_set_data_by_id';
procedure gtk_object_set_data_by_id_full(theobject:PGtkObject; data_id:TGQuark; data:gpointer; destroy:TGtkDestroyNotify);cdecl;external gtkdll name 'gtk_object_set_data_by_id_full';
function  gtk_object_get_data_by_id(theobject:PGtkObject; data_id:TGQuark):gpointer;cdecl;external gtkdll name 'gtk_object_get_data_by_id';
procedure gtk_object_remove_data_by_id(theobject:PGtkObject; data_id:TGQuark);cdecl;external gtkdll name 'gtk_object_remove_data_by_id';
{$ifndef gtkwin}
procedure gtk_object_remove_no_notify_by_id(theobject:PGtkObject; key_id:TGQuark);cdecl;external gtkdll name 'gtk_object_remove_no_notify_by_id';
{$endif}
procedure gtk_object_arg_set(theobject:PGtkObject; arg:PGtkArg; info:PGtkArgInfo);cdecl;external gtkdll name 'gtk_object_arg_set';
procedure gtk_object_arg_get(theobject:PGtkObject; arg:PGtkArg; info:PGtkArgInfo);cdecl;external gtkdll name 'gtk_object_arg_get';
function  gtk_object_args_collect(theobject_type:TGtkType; arg_list_p:PPGSList; info_list_p:PPGSList; first_arg_name:Pgchar; var_args:array of const):Pgchar;cdecl;external gtkdll name 'gtk_object_args_collect';
function  gtk_object_arg_get_info(theobject_type:TGtkType; arg_name:Pgchar; info_p:PPGtkArgInfo):Pgchar;cdecl;external gtkdll name 'gtk_object_arg_get_info';
procedure gtk_trace_referencing(theobject:PGtkObject; func:Pgchar; dummy:guint; line:guint; do_ref:gboolean);cdecl;external gtkdll name 'gtk_trace_referencing';

{$endif GTK10}


{$endif read_implementation}


{
  $Log: gtkobjects.pp,v $
  Revision 1.13  1999/06/29 23:46:53  peter
    * changed enums to constants

  Revision 1.12  1999/06/22 15:32:11  daniel
  *** empty log message ***

  Revision 1.11  1999/05/11 00:39:05  peter
    * win32 fixes

  Revision 1.10  1999/05/10 19:18:30  peter
    * more fixes for the examples to work

  Revision 1.9  1999/05/10 15:19:57  peter
    * cdecl fixes

  Revision 1.8  1999/05/10 09:03:33  peter
    * gtk 1.2 port working

  Revision 1.7  1999/05/07 15:10:10  peter
    * more fixes

  Revision 1.6  1999/05/07 10:40:36  peter
    * first things for 1.2

  Revision 1.5  1998/11/12 11:35:51  peter
    + array of const

  Revision 1.4  1998/11/09 10:10:17  peter
    + C type casts are now correctly handled

  Revision 1.3  1998/10/21 20:22:55  peter
    * cdecl, packrecord fixes (from the gtk.tar.gz)
    * win32 support
    * gtk.pp,gdk.pp for an all in one unit

}
